#ifndef _DTFORMBS_HPP
#define _DTFORMBS_HPP

#include "dtcodebk.hpp"
#include "mmdata.hpp"
#include "dttype.hpp"

class FormEdit;
class DTCodeBlockBase;
class DTCodeBlockList;
class MMEvent;
class DTWForm;
class DTWMenu;
class DTObject;
class DTJContainer;
class WOleStorage;

typedef class DTWForm DTForm;
typedef WCValOrderedVector< DTObject * > DTObjectList; // not the only def'n

class METACLASSDEF DTFormEditBase {
    public:
        // -- notification routines called by dtwclass -- //

        inline virtual ~DTFormEditBase() {}

        virtual WBool           DTValidateNameChange( DTObject * obj,
                                                      const WString & newName,
                                                      WString & error ) = 0;

        virtual WBool           DTNameChanged( DTObject * obj,
                                                const WString & newName ) = 0;
        virtual void            DTPropsChanged( WBool codeChanged ) = 0;

        virtual FormEdit *      GetDTFormEdit() = 0;
        virtual WForm *         GetDTFormWindow() = 0;
        virtual WOleContainer * GetDTFormContainer() = 0;
        virtual DTObject *      GetDTForm() const = 0;
        virtual DTForm *        GetDTFormObj() const = 0;
        virtual DTJContainer *  GetDTJContainerObj() const = 0;
        virtual DTObject *      GetDTMenu() = 0;
        virtual DTObject *      SetDTMenu( DTObject * ) = 0;

        virtual DTCodeBlockBase *MakeDTEvent( WString & obj_name,
                                              MMEvent *event_def ) = 0;
        virtual DTCodeBlockBase *FindOrAddEvent( const WString & str,
                                    DTObject * obj,
                                    MMEvent * definition = NULL ) = 0;
        virtual void            DTMoveControl(  DTObject * obj,
                                                const WRect & r ) = 0;
        virtual void            AddControl( DTObject * ) = 0;
        virtual void            GetDTWControlList( DTObjectList & ) = 0;
        virtual void            GetDTWMenuList( DTObjectList & ) = 0;
        virtual void            GetDTWPopupMenuList( DTObjectList & ) = 0;

        virtual void            GetUserFuncList( DTCodeBlockList& ,
                                                 WBool bGetProtoTypes = FALSE ) = 0;

        virtual unsigned        GetNumControls() = 0;
        virtual DTObject *      GetControl( unsigned idx ) = 0;

        // ---- OLE save / load / .rc interface ---- //

        virtual WString         GetOleUniqueID() = 0;
        virtual void            RemoveOleUniqueID( const WString & ) = 0;
        virtual WString         GetOleSaveFile( const WString & ) = 0;
        virtual WString         GetOleRCFile( const WString & ) = 0;

        virtual WBool           OpenOleSaveStg( void ) = 0;
        virtual WBool           CloseOleSaveStg( void ) = 0;
        virtual WOleStorage *   GetOleSaveStg( void ) = 0;

        virtual WBool           CreatePainter() = 0;
        virtual WBool           DestroyPainter() = 0;
};

#endif // _DTFORMBS_HPP

