#ifndef _MMCOMMON_HPP
#define _MMCOMMON_HPP

#include "mmdef.hpp"

class MMComponentLib;

class METACLASSDEF MMCommon : public WObject {
    public:
        MMCommon( const MMCommonData * data );
        MMCommon() : _data( NULL ) {}
        virtual ~MMCommon() = 0;

        virtual const MMCommonData * GetCommonData() const;

        virtual MMComponentLib *        GetLibrary() const;
        virtual WConstantString         GetName() const;
        virtual WInt                    GetIndex() const;
        virtual WBool                   operator==( const MMCommon & o ) const;
        virtual WBool                   operator<( const MMCommon & o ) const;
        virtual WBool                   operator>( const MMCommon & o ) const;

    protected:
        WBool   MakeString( MMString, WConstantString & ) const;
        MMComponentLib *        GetLib() const;

    protected:
        const MMCommonData *    _data;
};

#include "mmcomplb.hpp"

#endif // _MMCOMMON_HPP
