#ifndef _MMCOMP_HPP
#define _MMCOMP_HPP

#include "mmcommon.hpp"
#include "mmdef.hpp"

class MMProperty;
class MMEventOverride;

class METACLASSDEF MMComponent : public MMCommon {
    public:
        MMComponent( const MMComponentData * );
        MMComponent() {}

        virtual WConstantString         GetVarName() const;
        virtual WConstantString         GetToolPage() const;
        virtual WConstantString         GetToolPalette() const;
        virtual WInt                    GetToolPriority() const;
        virtual WConstantString         GetDescription() const;
        virtual WConstantString         GetRefTag() const;
        virtual WUInt                   GetNumIncludes() const;
        virtual WConstantString         GetInclude( WUInt idx ) const;
        virtual WBool                   GetNeedRegisteredClass() const;
        virtual WBool                   GetNonVisual() const;
        virtual WBool                   GetRequireForm() const;
        virtual WBool                   GetIsJavaBean() const;
        virtual WConstantString         GetJavaCustomizerClass() const;
        virtual WBool                   GetIsJavaApplet() const;
        virtual long                    GetNonVisualResID() const;
        virtual WBool                   InvokeHelp( WApplication *, WWindow * ) const;
        virtual const MMComponent *     GetBase() const;
        virtual const MMReferenceNode * GetReferenceRoot() const;

        virtual unsigned                GetNumDDXTypes() const;
        virtual WConstantString         GetDDXType( unsigned i ) const;
        virtual const MMProperty *      GetDDXProperty() const;
        virtual WBool                   GetInvisible() const;
        virtual WBool                   GetComponent() const;
        virtual WSize                   GetDefaultSize() const;

        virtual WUInt                   GetNumEvents() const;
        virtual const MMEvent *         GetEvent( WUInt idx ) const;
        virtual WUInt                   GetNumHotEvents() const;
        virtual const MMEvent *         GetHotEvent( WUInt idx ) const;
        virtual WUInt                   GetNumStyles() const;
        virtual const MMStyle *         GetStyle( WUInt idx ) const;
        virtual WUInt                   GetNumProperties() const;
        virtual const MMProperty *      GetProperty( WUInt idx ) const;
        virtual WUInt                   GetNumMethods() const;
        virtual const MMMethod *        GetMethod( WUInt idx ) const;
        virtual WUInt                   GetNumPropertySheets() const;
        virtual const MMPropertySheet * GetPropertySheet( WUInt idx ) const;
        virtual WConstantString         GetReserved() const;
        virtual WBool                   GetEventStructOverridden() const;

        // obsolete, remove ASAP
        virtual void                    GetDDXProperty( MMProperty & p ) const;
};

#endif // _MMCOMP_HPP
