#ifndef _MMDEF_HPP
#define _MMDEF_HPP

#include "mtdef.hpp"

class  DTObject;
class  DTType;
class  MetaObject;
class  MMBaseProperty;
class  MMCommon;
class  MMComponent;
class  MMComponentLib;
class  MMEnumerator;
class  MMEvent;
class  MMEventOverride;
class  MMMethod;
class  MMParameter;
class  MMParameterSet;
class  MMProperty;
class  MMPropertyGroup;
class  MMPropertyControl;
class  MMPropertySheet;
class  MMReferenceNode;
class  MMStyle;
class  MMType;
class  MTPropertyControl;
class  MTPropertySheetBase;
class  SaveItem;
class  SaveSource;
class  PropertyInspectObject;
class  PropertyInspector;

struct MMBasePropertyData;
struct MMHelpID;

class DTType;

enum MMString { MMSTRING_NULL = 0 };
enum MMIndex { MMINDEX_NULL = -1 };
enum MMOffset { MMOFFSET_NULL = -1 };
enum MMSetFnIndex { MMSETFNINDEX_NULL = -1 };
enum MMGetFnIndex { MMGETFNINDEX_NULL = -1 };
enum MMPropCtrlFnIndex { MMPROPCTRLINDEX_NULL = -1 };
enum MMPropSheetFnIndex { MMPROPSHTINDEX_NULL = -1 };
enum MMDTInstFnIndex { MMINSTFNINDEX_NULL = -1 };
enum MMDTTypeFnIndex { MMTYPEFNINDEX_NULL = -1 };
enum MMPropDefFnIndex { MMPROPDEFFNINDEX_NULL = -1 };
enum MMPropMakeEditorFnIndex { MMPROPEDITORFNINDEX_NULL = -1 };

typedef unsigned MMVerification;
#define MMVERIFY_GOOD   0xda7aba5e


typedef WBool                 METADEF (*MMSetPropFn)(
                                        DTObject * obj,
                                        const DTType * val,
                                        const MMBaseProperty * data );

typedef DTType *              METADEF (*MMGetPropFn)(
                                        const DTObject * obj,
                                        const MMBaseProperty * data );

typedef MTPropertySheetBase * METADEF (*MMMakePropSheet)(
                                        const MMPropertySheet * );

typedef MTPropertyControl *   METADEF (*MMMakePropControl)(
                                        const MMPropertyControl * );

typedef DTObject *            METADEF (*MMMakeDTObject)(
                                        const MetaObject * );

typedef DTType *              METADEF (*MMMakeDTType)(
                                        const MMType * );

typedef WBool                 METADEF (*MMPropDefault)(
                                        const DTObject * obj,
                                        const MMBaseProperty * prop );

typedef PropertyInspectObject *  METADEF (*MMPropMakeEditor)(
                                        const MMProperty * prop,
                                        PropertyInspector * prt,
                                        WUInt numObjects,
                                        DTObject ** objects );
enum MMFunctionType {
    MMFT_SetPropFn,
    MMFT_GetPropFn,
    MMFT_MakePropSheetFn,
    MMFT_MakePropControl,
    MMFT_MakeDTObject,
    MMFT_MakeDTType,
    MMFT_PropDefault,
    MMFT_PropMakeEditor,
    MMFT_NumFunctionTypes
};

struct MMCommonData;
struct MMEventData;
struct MMBaseTypeData;
struct MMTypeData;
struct MMStructTypeData;
struct MMParameterData;
struct MMParameterSetData;
struct MMBasePropertyData;
struct MMStyleData;
struct MMPropertyData;
struct MMMethodData;
struct MMPropertyControlData;
struct MMPropertySheetData;
struct MMReferenceNodeData;
struct MMComponentData;
struct MMLibraryData;

/**********************
 *** MMFunctionData ***
 **********************/

typedef void (*MMFnPtr)();
struct MMFunctionData {
    MMFnPtr                 function;
    MMString                name;       // NULL is invalid
    WULong                  flags;      // bit-field of flags
    MMString                libraryName;// may not be valid if already snapped
};

struct MMStyleList {
    unsigned            entries;
    const MMStyle **    vector;
};

struct MMEventList {
    unsigned            entries;
    const MMEvent **    vector;
};

struct MMMethodList {
    unsigned            entries;
    const MMMethod **   vector;
};

struct MMPropertyList {
    unsigned            entries;
    const MMProperty ** vector;
};

struct MMPropertySheetList {
    unsigned                    entries;
    const MMPropertySheet **    vector;
};

/***************************
 *** Function Prototypes ***
 ***************************/

extern DTType *  METAEXPORTDEF MMStyleGet( const DTObject *, const MMBaseProperty * );
extern WBool     METAEXPORTDEF MMStyleSet( DTObject *, const DTType *,
                                   const MMBaseProperty * );
extern MTPropertySheetBase * METAEXPORTDEF MakePropertySheet( const MMPropertySheet * );
extern MTPropertyControl *   METAEXPORTDEF MakePropertyControl( const MMPropertyControl * );


#ifndef DLL_PROCESS_ATTACH
#  define DLL_PROCESS_ATTACH 1
#  define DLL_THREAD_ATTACH  2
#  define DLL_THREAD_DETACH  3
#  define DLL_PROCESS_DETACH 0
#endif

#endif // _MMDEF_HPP
