#ifndef _MMPARM_HPP
#define _MMPARM_HPP

#include "mmtype.hpp"

class METACLASSDEF MMParameter : public MMCommon {
    public:
        MMParameter( const MMParameterData * parm );
        MMParameter() {}

        virtual const MMType *  GetType() const;
        virtual WConstantString GetDesc() const;
        virtual WBool           GetOptional() const;
        virtual WConstantString GetDefault() const;
};

class METACLASSDEF MMParameterSet : public MMCommon {
    public:
        MMParameterSet( const MMParameterSetData * set );
        MMParameterSet() {}

        virtual const MMType *          GetReturnType() const;
        virtual unsigned                GetNumParameters() const;
        virtual const MMParameter *     GetParameter( unsigned i ) const;
        virtual WConstantString         GetDecorated() const;
};

#endif // _MMPARM_HPP
