#ifndef _MMPROP_HPP
#define _MMPROP_HPP

//#include "mmdata.hpp"
#include "mmcommon.hpp"
#include "mmtype.hpp"
//#include "mmparm.hpp"

class WStringList;

class METACLASSDEF MMBaseProperty : public MMCommon {
    public:
        MMBaseProperty( const MMBasePropertyData * data );
        MMBaseProperty() {}

        virtual const MMType *  GetType() const;

        virtual WBool           SetProp( DTObject * obj,
                                         const DTType * val ) const;
        virtual DTType *        GetProp( const DTObject * obj ) const;
        virtual WBool           GetDefault( const DTObject * obj ) const;

        virtual WBool           GetIsStyle() const;
        virtual WBool           GetRunTimeCode() const;
        virtual WBool           GetCreateTime() const;
        virtual WBool           GetRunTimeOnly() const;
        virtual WBool           GetRedrawRequired() const;
        virtual WBool           GetReadOnly() const;
        virtual WBool           GetSaved() const;
        virtual WLong           GetPriority() const;
        virtual WLong           GetDefCookie() const;
        virtual WBool           GetMapped() const;
        virtual WLong           GetContextHelpID() const;
        virtual WBool           InvokeContextHelp( WWindow *, WHelpEventData * event );
        virtual WBool           GetBound() const;
        virtual WBool           GetConstrained() const;

        virtual WConstantString GetSaveTag() const;
        virtual WBool           Save( const DTObject *, SaveSource & ) const;
        virtual WBool           Load( DTObject *, SaveItem * ) const;
};

class METACLASSDEF MMProperty : public MMBaseProperty {
    public:
        MMProperty( const MMPropertyData * data );
        MMProperty() {}

        virtual unsigned                GetNumParameterSets() const;
        virtual const MMParameterSet *  GetParameterSet( unsigned idx ) const;

        virtual WBool                   Save( const DTObject *, SaveSource & ) const;
        virtual WBool                   Load( DTObject *, SaveItem * ) const;

        virtual WBool                   GenerateCode( ostream & src, const DTObject *, const WString & pfx ) const;
        virtual WBool                   GenRTCode( const DTObject *, WStringList &,
                                                    const WString & pfx ) const;
        virtual WBool                   InvokeHelp( WApplication *, WWindow * ) const;

        virtual WConstantString         GetDefaultMapped() const;
        virtual PropertyInspectObject * MakePropertyEditor(
                                            PropertyInspector * prt,
                                            WUInt n, DTObject ** objects ) const;

        virtual WBool                   GetFDXEnabled() const;
        virtual WConstantString         GetPropertyEditor() const;
};

#endif // _MMPROP_HPP
