#ifndef _MMTYPE_HPP
#define _MMTYPE_HPP

#include "mmcommon.hpp"

class DTType;
struct MMEnumeratorData;

class METACLASSDEF MMEnumerator : public MMCommon {
    public:
        MMEnumerator( const MMEnumeratorData * edat );
        MMEnumerator(){}

        virtual long                    GetValue() const;
};

class METACLASSDEF MMType : public MMCommon {
    public:
        MMType( const MMTypeData * type );
        MMType(){}

        virtual WConstantString         GetType() const;

        virtual unsigned                GetNumEnumerators() const;
        virtual const MMEnumerator *    GetEnumerator( unsigned idx ) const;

        virtual WBool                   GetWantBrowse() const;
        virtual WConstantString         GetBrowseName() const;

        virtual DTType *                Instantiate() const;

        virtual WString                 GetMakeFunctionName() const;
        virtual WBool                   GetDesignTime() const;
        virtual WString                 GetTypeName() const;
};

#endif // _MMTYPE_HPP
