#ifndef _MTDEF_HPP
#define _MTDEF_HPP


//
// Define the calling convention.  We use __stdcall for portability.
//

#define METADEF  WCMDEF

//
// Define macros for importing & exporting things.
//

#define METADECLSPEC_IMPORT //__declspec(dllimport)
#define METADECLSPEC_EXPORT __declspec(dllexport)

#define OCXDECLSPEC_IMPORT //__declspec(dllimport)
#define OCXDECLSPEC_EXPORT __declspec(dllexport)

//
// Compile-time switches control how we define our classes.
//

//
// Normal, un-exported classes (temporarily, all classes
// are exported).
//
#if defined( __BUILDING_DTWCM_DLL__ ) || defined( __BUILDING_DTJVA_DLL__ )
//#define METACLASSDEF METADEF
#define METACLASSDEF METADECLSPEC_EXPORT METADEF
#else
//#define METACLASSDEF METADEF
#define METACLASSDEF METADECLSPEC_IMPORT METADEF
#endif

//
// Explicitly exported classes
//
#if defined( __BUILDING_DTWCM_DLL__ ) || defined( __BUILDING_DTJVA_DLL__ ) || defined( __BUILDING_DTJCL_DLL )
#define METAEXPORTCLASSDEF METADECLSPEC_EXPORT METADEF
#else
#define METAEXPORTCLASSDEF METADECLSPEC_IMPORT METADEF
#endif

//
// Explicitly exported functions
//
#if defined( __BUILDING_DTWCM_DLL__ ) || defined( __BUILDING_DTJVA_DLL__ )
#define METAEXPORTDEF __export METADEF
#else
#define METAEXPORTDEF METADEF
#endif

#ifdef __BUILDING_OCX_DLL__
#define OCXCLASSDEF OCXDECLSPEC_EXPORT METADEF
#else
#define OCXCLASSDEF OCXDECLSPEC_IMPORT METADEF
#endif

#ifdef __BUILDING_DTWACTVX_DLL__
#define ACTVX_METAEXPORTCLASSDEF METADECLSPEC_EXPORT METADEF
#else
#define ACTVX_METAEXPORTCLASSDEF METADECLSPEC_IMPORT METADEF
#endif

enum MMLanguage {
    MMLanguageCpp               = 0,
    MMLanguageJava              = 1,
};

#endif // _MTDEF_HPP
