/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1994, by WATCOM International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of WATCOM International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*/

/*************************************************************************
 *
 * WCommandButton -- Wrapper for the Windows 95 Push button control.
 *
 *   Events:
 *
 *************************************************************************/

#ifndef _WCOMBTTN_HPP_INCLUDED
#define _WCOMBTTN_HPP_INCLUDED
#pragma once

#ifndef _WNO_PRAGMA_PUSH
#pragma pack(push,8);
#pragma enum int;
#endif

#ifndef _WBUTTON_HPP_INCLUDED
#  include "wbutton.hpp"
#endif

class WCMCLASS WCommandButton : public WButton {

    WDeclareSubclass( WCommandButton, WButton )

    public:
    
        /**************************************************************
         * Constructors and Destructors
         **************************************************************/

        WCommandButton();
    
        ~WCommandButton();
    
        /**************************************************************
         * Properties
         **************************************************************/

        // Cancel

        WBool SetCancel( WBool iscancel );
        WBool GetCancel();

        // FDXDataSource

        WBool SetFDXDataSource( WBool * fdxDataSource );

        // Default

        WBool SetDefault( WBool isDefault );
        WBool GetDefault();

        // Pressed

        WBool SetPressed( WBool pressed );
        WBool GetPressed() const;

        /**************************************************************
         * Methods
         **************************************************************/

        /**************************************************************
         * Overrides
         **************************************************************/

        virtual WBool FDXIn();

        virtual WBool FDXOut();

        virtual WBool AutoSize();

        virtual const WChar * InitializeClass();

        virtual WStyle GetDefaultStyle() const;

        virtual WBool CloneWindow( WStyle newStyle, WStyle newExStyle,
                                   void * data=NULL );

        /**************************************************************
         * Data members
         **************************************************************/

    private:

        WBool *         _fdxDataSource;
        WBool           _cancel;
};

#ifndef _WNO_PRAGMA_PUSH
#pragma enum pop;
#pragma pack(pop);
#endif

#endif // _WCOMBTTN_HPP_INCLUDED
