/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1994, by WATCOM International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or       %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or       %
   %     information storage and retrieval systems - except with the     %
   %     written permission of WATCOM International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*/

#ifndef _WDRAWITM_HPP_INCLUDED
#define _WDRAWITM_HPP_INCLUDED

#ifndef _WNO_PRAGMA_PUSH
#pragma pack(push,8);
#pragma enum int;
#endif

#ifndef _WEVENTD_HPP_INCLUDED
#   include "weventd.hpp"
#endif

class WDisplayCanvas;

// These match the ODA_* types in windows.h

enum WDrawItemAction {
    WDrawItemEntire             = 0x0001,
    WDrawItemSelectedChanging   = 0x0002,
    WDrawItemFocusChanging      = 0x0004,
};

// These match the ODS_* types in windows.h

enum WDrawItemState {
    WDrawItemSelected           = 0x0001,
    WDrawItemGrayed             = 0x0002,
    WDrawItemDisabled           = 0x0004,
    WDrawItemChecked            = 0x0008,
    WDrawItemWithFocus          = 0x0010,
    WDrawItemAsDefault          = 0x0020,
    WDrawItemAsComboboxEdit     = 0x1000,
};

// These match the ODT_* types in windows.h and commctrl.h

enum WDrawItemType {
    WDrawItemMenu               = 1,
    WDrawItemListbox            = 2,
    WDrawItemCombobox           = 3,
    WDrawItemButton             = 4,
    WDrawItemStatic             = 5,
    WDrawItemHeader             = 100,
    WDrawItemTabControl         = 101,
    WDrawItemListView           = 102,
};

struct WDrawItemEventData : public WEventData {
    WDrawItemType       type;
    WWindowHandle       control;
    WULong              controlID;
    WULong              itemID;
    WULong              itemData;
    WDrawItemAction     action;
    WDrawItemState      state;
    WRect               rcItem;
    WDisplayCanvas *    canvas;
};

struct WMeasureItemEventData : public WEventData {
    WDrawItemType       type;
    WWindowHandle       control;
    WULong              controlID;
    WULong              itemID;
    WULong              itemData;
    WULong              itemWidth;
    WULong              itemHeight;
};

struct WCompareItemEventData : public WEventData {
    WDrawItemType       type;
    WWindowHandle       control;
    WULong              controlID;
    WULong              itemID1;
    WULong              itemData1;
    WULong              itemID2;
    WULong              itemData2;
};

struct WDeleteItemEventData : public WEventData {
    WDrawItemType       type;
    WWindowHandle       control;
    WULong              controlID;
    WULong              itemID;
    WULong              itemData;

};

#ifndef _WNO_PRAGMA_PUSH
#pragma enum pop;
#pragma pack(pop);
#endif

#endif // _WDRAWITM_HPP_INCLUDED

