/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by WATCOM International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of WATCOM International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*/

#ifndef _WERROR_HPP_INCLUDED
#define _WERROR_HPP_INCLUDED

#ifndef _WNO_PRAGMA_PUSH
#pragma pack(push,8);
#pragma enum int;
#endif

#ifndef _WSTRING_HPP_INCLUDED
#   include     "wstring.hpp"
#endif

#include "werrcode.hpp"

enum WErrorCode {
    WERROR_SUCCESS                              = 0L,
    WERROR_INVALID_FUNCTION,
    WERROR_FILE_NOT_FOUND,
    WERROR_PATH_NOT_FOUND,
    WERROR_TOO_MANY_OPEN_FILES,
    WERROR_ACCESS_DENIED,
    WERROR_INVALID_HANDLE,
    WERROR_ARENA_TRASHED,
    WERROR_NOT_ENOUGH_MEMORY,
    WERROR_INVALID_BLOCK,
    WERROR_BAD_ENVIRONMENT,
    WERROR_BAD_FORMAT,
    WERROR_INVALID_ACCESS,
    WERROR_INVALID_DATA,
    WERROR_OUTOFMEMORY,
    WERROR_INVALID_DRIVE,
    WERROR_CURRENT_DIRECTORY,
    WERROR_NOT_SAME_DEVICE,
    WERROR_NO_MORE_FILES,
    WERROR_WRITE_PROTECT,
    WERROR_BAD_UNIT,
    WERROR_NOT_READY,
    WERROR_BAD_COMMAND,
    WERROR_CRC,
    WERROR_BAD_LENGTH,
    WERROR_SEEK,
    WERROR_NOT_DOS_DISK,
    WERROR_SECTOR_NOT_FOUND,
    WERROR_OUT_OF_PAPER,
    WERROR_WRITE_FAULT,
    WERROR_READ_FAULT,
    WERROR_GEN_FAILURE,
    WERROR_SHARING_VIOLATION,
    WERROR_LOCK_VIOLATION,
    WERROR_WRONG_DISK,
    WERROR_SHARING_BUFFER_EXCEEDED              = 36L,
    WERROR_HANDLE_EOF                           = 38L,
    WERROR_HANDLE_DISK_FULL,
    WERROR_NOT_SUPPORTED                        = 50L,
    WERROR_REM_NOT_LIST,
    WERROR_DUP_NAME,
    WERROR_BAD_NETPATH,
    WERROR_NETWORK_BUSY,
    WERROR_DEV_NOT_EXIST,
    WERROR_TOO_MANY_CMDS,
    WERROR_ADAP_HDW_ERR,
    WERROR_BAD_NET_RESP,
    WERROR_UNEXP_NET_ERR,
    WERROR_BAD_REM_ADAP,
    WERROR_PRINTQ_FULL,
    WERROR_NO_SPOOL_SPACE,
    WERROR_PRINT_CANCELLED,
    WERROR_NETNAME_DELETED,
    WERROR_NETWORK_ACCESS_DENIED,
    WERROR_BAD_DEV_TYPE,
    WERROR_BAD_NET_NAME,
    WERROR_TOO_MANY_NAMES,
    WERROR_TOO_MANY_SESS,
    WERROR_SHARING_PAUSED,
    WERROR_REQ_NOT_ACCEP,
    WERROR_REDIR_PAUSED,
    WERROR_FILE_EXISTS                          = 80L,
    WERROR_CANNOT_MAKE                          = 82L,
    WERROR_FAIL_I24,
    WERROR_OUT_OF_STRUCTURES,
    WERROR_ALREADY_ASSIGNED,
    WERROR_INVALID_PASSWORD,
    WERROR_INVALID_PARAMETER,
    WERROR_NET_WRITE_FAULT,
    WERROR_NO_PROC_SLOTS,
    WERROR_TOO_MANY_SEMAPHORES                  = 100L,
    WERROR_EXCL_SEM_ALREADY_OWNED,
    WERROR_SEM_IS_SET,
    WERROR_TOO_MANY_SEM_REQUESTS,
    WERROR_INVALID_AT_INTERRUPT_TIME,
    WERROR_SEM_OWNER_DIED,
    WERROR_SEM_USER_LIMIT,
    WERROR_DISK_CHANGE,
    WERROR_DRIVE_LOCKED,
    WERROR_BROKEN_PIPE,
    WERROR_OPEN_FAILED,
    WERROR_BUFFER_OVERFLOW,
    WERROR_DISK_FULL,
    WERROR_NO_MORE_SEARCH_HANDLES,
    WERROR_INVALID_TARGET_HANDLE,
    WERROR_INVALID_CATEGORY                     = 117L,
    WERROR_INVALID_VERIFY_SWITCH,
    WERROR_BAD_DRIVER_LEVEL,
    WERROR_CALL_NOT_IMPLEMENTED,
    WERROR_SEM_TIMEOUT,
    WERROR_INSUFFICIENT_BUFFER,
    WERROR_INVALID_NAME,
    WERROR_INVALID_LEVEL,
    WERROR_NO_VOLUME_LABEL,
    WERROR_MOD_NOT_FOUND,
    WERROR_PROC_NOT_FOUND,
    WERROR_WAIT_NO_CHILDREN,
    WERROR_CHILD_NOT_COMPLETE,
    WERROR_DIRECT_ACCESS_HANDLE,
    WERROR_NEGATIVE_SEEK,
    WERROR_SEEK_ON_DEVICE,
    WERROR_IS_JOIN_TARGET,
    WERROR_IS_JOINED,
    WERROR_IS_SUBSTED,
    WERROR_NOT_JOINED,
    WERROR_NOT_SUBSTED,
    WERROR_JOIN_TO_JOIN,
    WERROR_SUBST_TO_SUBST,
    WERROR_JOIN_TO_SUBST,
    WERROR_SUBST_TO_JOIN,
    WERROR_BUSY_DRIVE,
    WERROR_SAME_DRIVE,
    WERROR_DIR_NOT_ROOT,
    WERROR_DIR_NOT_EMPTY,
    WERROR_IS_SUBST_PATH,
    WERROR_IS_JOIN_PATH,
    WERROR_PATH_BUSY,
    WERROR_IS_SUBST_TARGET,
    WERROR_SYSTEM_TRACE,
    WERROR_INVALID_EVENT_COUNT,
    WERROR_TOO_MANY_MUXWAITERS,
    WERROR_INVALID_LIST_FORMAT,
    WERROR_LABEL_TOO_LONG,
    WERROR_TOO_MANY_TCBS,
    WERROR_SIGNAL_REFUSED,
    WERROR_DISCARDED,
    WERROR_NOT_LOCKED,
    WERROR_BAD_THREADID_ADDR,
    WERROR_BAD_ARGUMENTS,
    WERROR_BAD_PATHNAME,
    WERROR_SIGNAL_PENDING,
    WERROR_MAX_THRDS_REACHED                    = 164L,
    WERROR_LOCK_FAILED                          = 167L,
    WERROR_BUSY                                 = 170L,
    WERROR_CANCEL_VIOLATION                     = 173L,
    WERROR_ATOMIC_LOCKS_NOT_SUPPORTED,
    WERROR_INVALID_SEGMENT_NUMBER               = 180L,
    WERROR_INVALID_ORDINAL                      = 182L,
    WERROR_ALREADY_EXISTS,
    WERROR_INVALID_FLAG_NUMBER                  = 186L,
    WERROR_SEM_NOT_FOUND,
    WERROR_INVALID_STARTING_CODESEG,
    WERROR_INVALID_STACKSEG,
    WERROR_INVALID_MODULETYPE,
    WERROR_INVALID_EXE_SIGNATURE,
    WERROR_EXE_MARKED_INVALID,
    WERROR_BAD_EXE_FORMAT,
    WERROR_ITERATED_DATA_EXCEEDS_64k,
    WERROR_INVALID_MINALLOCSIZE,
    WERROR_DYNLINK_FROM_INVALID_RING,
    WERROR_IOPL_NOT_ENABLED,
    WERROR_INVALID_SEGDPL,
    WERROR_AUTODATASEG_EXCEEDS_64k,
    WERROR_RING2SEG_MUST_BE_MOVABLE,
    WERROR_RELOC_CHAIN_XEEDS_SEGLIM,
    WERROR_INFLOOP_IN_RELOC_CHAIN,
    WERROR_ENVVAR_NOT_FOUND,
    WERROR_NO_SIGNAL_SENT                       = 205L,
    WERROR_FILENAME_EXCED_RANGE,
    WERROR_RING2_STACK_IN_USE,
    WERROR_META_EXPANSION_TOO_LONG,
    WERROR_INVALID_SIGNAL_NUMBER,
    WERROR_THREAD_1_INACTIVE,
    WERROR_LOCKED                               = 212L,
    WERROR_TOO_MANY_MODULES                     = 214L,
    WERROR_NESTING_NOT_ALLOWED,
    WERROR_BAD_PIPE                             = 230L,
    WERROR_PIPE_BUSY,
    WERROR_NO_DATA,
    WERROR_PIPE_NOT_CONNECTED,
    WERROR_MORE_DATA,
    WERROR_VC_DISCONNECTED                      = 240L,
    WERROR_INVALID_EA_NAME                      = 254L,
    WERROR_EA_LIST_INCONSISTENT,
    WERROR_NO_MORE_ITEMS                        = 259L,
    WERROR_CANNOT_COPY                          = 266L,
    WERROR_DIRECTORY,
    WERROR_EAS_DIDNT_FIT                        = 275L,
    WERROR_EA_FILE_CORRUPT,
    WERROR_EA_TABLE_FULL,
    WERROR_INVALID_EA_HANDLE,
    WERROR_EAS_NOT_SUPPORTED                    = 282L,
    WERROR_NOT_OWNER                            = 288L,
    WERROR_TOO_MANY_POSTS                       = 298L,
    WERROR_PARTIAL_COPY,
    WERROR_MR_MID_NOT_FOUND                     = 317L,
    WERROR_INVALID_ADDRESS                      = 487L,
    WERROR_ARITHMETIC_OVERFLOW                  = 534L,
    WERROR_PIPE_CONNECTED,
    WERROR_PIPE_LISTENING,
    WERROR_EA_ACCESS_DENIED                     = 994L,
    WERROR_OPERATION_ABORTED,
    WERROR_IO_INCOMPLETE,
    WERROR_IO_PENDING,
    WERROR_NOACCESS,
    WERROR_SWAPERROR,
    WERROR_STACK_OVERFLOW                       = 1001L,
    WERROR_INVALID_MESSAGE,
    WERROR_CAN_NOT_COMPLETE,
    WERROR_INVALID_FLAGS,
    WERROR_UNRECOGNIZED_VOLUME,
    WERROR_FILE_INVALID,
    WERROR_FULLSCREEN_MODE,
    WERROR_NO_TOKEN,
    WERROR_BADDB,
    WERROR_BADKEY,
    WERROR_CANTOPEN,
    WERROR_CANTREAD,
    WERROR_CANTWRITE,
    WERROR_REGISTRY_RECOVERED,
    WERROR_REGISTRY_CORRUPT,
    WERROR_REGISTRY_IO_FAILED,
    WERROR_NOT_REGISTRY_FILE,
    WERROR_KEY_DELETED,
    WERROR_NO_LOG_SPACE,
    WERROR_KEY_HAS_CHILDREN,
    WERROR_CHILD_MUST_BE_VOLATILE,
    WERROR_NOTIFY_ENUM_DIR,
    WERROR_DEPENDENT_SERVICES_RUNNING           = 1051L,
    WERROR_INVALID_SERVICE_CONTROL,
    WERROR_SERVICE_REQUEST_TIMEOUT,
    WERROR_SERVICE_NO_THREAD,
    WERROR_SERVICE_DATABASE_LOCKED,
    WERROR_SERVICE_ALREADY_RUNNING,
    WERROR_INVALID_SERVICE_ACCOUNT,
    WERROR_SERVICE_DISABLED,
    WERROR_CIRCULAR_DEPENDENCY,
    WERROR_SERVICE_DOES_NOT_EXIST,
    WERROR_SERVICE_CANNOT_ACCEPT_CTRL,
    WERROR_SERVICE_NOT_ACTIVE,
    WERROR_FAILED_SERVICE_CONTROLLER_CONNECT,
    WERROR_EXCEPTION_IN_SERVICE,
    WERROR_DATABASE_DOES_NOT_EXIST,
    WERROR_SERVICE_SPECIFIC_ERROR,
    WERROR_PROCESS_ABORTED,
    WERROR_SERVICE_DEPENDENCY_FAIL,
    WERROR_SERVICE_LOGON_FAILED,
    WERROR_SERVICE_START_HANG,
    WERROR_INVALID_SERVICE_LOCK,
    WERROR_SERVICE_MARKED_FOR_DELETE,
    WERROR_SERVICE_EXISTS,
    WERROR_ALREADY_RUNNING_LKG,
    WERROR_SERVICE_DEPENDENCY_DELETED,
    WERROR_BOOT_ALREADY_ACCEPTED,
    WERROR_SERVICE_NEVER_STARTED,
    WERROR_DUPLICATE_SERVICE_NAME,
    WERROR_END_OF_MEDIA                         = 1100L,
    WERROR_FILEMARK_DETECTED,
    WERROR_BEGINNING_OF_MEDIA,
    WERROR_SETMARK_DETECTED,
    WERROR_NO_DATA_DETECTED,
    WERROR_PARTITION_FAILURE,
    WERROR_INVALID_BLOCK_LENGTH,
    WERROR_DEVICE_NOT_PARTITIONED,
    WERROR_UNABLE_TO_LOCK_MEDIA,
    WERROR_UNABLE_TO_UNLOAD_MEDIA,
    WERROR_MEDIA_CHANGED,
    WERROR_BUS_RESET,
    WERROR_NO_MEDIA_IN_DRIVE,
    WERROR_NO_UNICODE_TRANSLATION,
    WERROR_DLL_INIT_FAILED,
    WERROR_SHUTDOWN_IN_PROGRESS,
    WERROR_NO_SHUTDOWN_IN_PROGRESS,
    WERROR_IO_DEVICE,
    WERROR_SERIAL_NO_DEVICE,
    WERROR_IRQ_BUSY,
    WERROR_MORE_WRITES,
    WERROR_COUNTER_TIMEOUT,
    WERROR_FLOPPY_ID_MARK_NOT_FOUND,
    WERROR_FLOPPY_WRONG_CYLINDER,
    WERROR_FLOPPY_UNKNOWN_ERROR,
    WERROR_FLOPPY_BAD_REGISTERS,
    WERROR_DISK_RECALIBRATE_FAILED,
    WERROR_DISK_OPERATION_FAILED,
    WERROR_DISK_RESET_FAILED,
    WERROR_EOM_OVERFLOW,
    WERROR_NOT_ENOUGH_SERVER_MEMORY,
    WERROR_POSSIBLE_DEADLOCK,
    WERROR_MAPPED_ALIGNMENT,
    WERROR_BAD_DEVICE                           = 1200L,
    WERROR_CONNECTION_UNAVAIL,
    WERROR_DEVICE_ALREADY_REMEMBERED,
    WERROR_NO_NET_OR_BAD_PATH,
    WERROR_BAD_PROVIDER,
    WERROR_CANNOT_OPEN_PROFILE,
    WERROR_BAD_PROFILE,
    WERROR_NOT_CONTAINER,
    WERROR_EXTENDED_ERROR,
    WERROR_INVALID_GROUPNAME,
    WERROR_INVALID_COMPUTERNAME,
    WERROR_INVALID_EVENTNAME,
    WERROR_INVALID_DOMAINNAME,
    WERROR_INVALID_SERVICENAME,
    WERROR_INVALID_NETNAME,
    WERROR_INVALID_SHARENAME,
    WERROR_INVALID_PASSWORDNAME,
    WERROR_INVALID_MESSAGENAME,
    WERROR_INVALID_MESSAGEDEST,
    WERROR_SESSION_CREDENTIAL_CONFLICT,
    WERROR_REMOTE_SESSION_LIMIT_EXCEEDED,
    WERROR_DUP_DOMAINNAME,
    WERROR_NO_NETWORK,
    WERROR_CANCELLED,
    WERROR_USER_MAPPED_FILE,
    WERROR_CONNECTION_REFUSED,
    WERROR_GRACEFUL_DISCONNECT,
    WERROR_ADDRESS_ALREADY_ASSOCIATED,
    WERROR_ADDRESS_NOT_ASSOCIATED,
    WERROR_CONNECTION_INVALID,
    WERROR_CONNECTION_ACTIVE,
    WERROR_NETWORK_UNREACHABLE,
    WERROR_HOST_UNREACHABLE,
    WERROR_PROTOCOL_UNREACHABLE,
    WERROR_PORT_UNREACHABLE,
    WERROR_REQUEST_ABORTED,
    WERROR_CONNECTION_ABORTED,
    WERROR_RETRY,
    WERROR_CONNECTION_COUNT_LIMIT,
    WERROR_LOGIN_TIME_RESTRICTION,
    WERROR_LOGIN_WKSTA_RESTRICTION,
    WERROR_INCORRECT_ADDRESS,
    WERROR_ALREADY_REGISTERED,
    WERROR_SERVICE_NOT_FOUND,
    WERROR_NOT_AUTHENTICATED,
    WERROR_NOT_LOGGED_ON,
    WERROR_CONTINUE,
    WERROR_ALREADY_INITIALIZED,
    WERROR_NO_MORE_DEVICES,
    WERROR_NOT_ALL_ASSIGNED                     = 1300L,
    WERROR_SOME_NOT_MAPPED,
    WERROR_NO_QUOTAS_FOR_ACCOUNT,
    WERROR_LOCAL_USER_SESSION_KEY,
    WERROR_NULL_LM_PASSWORD,
    WERROR_UNKNOWN_REVISION,
    WERROR_REVISION_MISMATCH,
    WERROR_INVALID_OWNER,
    WERROR_INVALID_PRIMARY_GROUP,
    WERROR_NO_IMPERSONATION_TOKEN,
    WERROR_CANT_DISABLE_MANDATORY,
    WERROR_NO_LOGON_SERVERS,
    WERROR_NO_SUCH_LOGON_SESSION,
    WERROR_NO_SUCH_PRIVILEGE,
    WERROR_PRIVILEGE_NOT_HELD,
    WERROR_INVALID_ACCOUNT_NAME,
    WERROR_USER_EXISTS,
    WERROR_NO_SUCH_USER,
    WERROR_GROUP_EXISTS,
    WERROR_NO_SUCH_GROUP,
    WERROR_MEMBER_IN_GROUP,
    WERROR_MEMBER_NOT_IN_GROUP,
    WERROR_LAST_ADMIN,
    WERROR_WRONG_PASSWORD,
    WERROR_ILL_FORMED_PASSWORD,
    WERROR_PASSWORD_RESTRICTION,
    WERROR_LOGON_FAILURE,
    WERROR_ACCOUNT_RESTRICTION,
    WERROR_INVALID_LOGON_HOURS,
    WERROR_INVALID_WORKSTATION,
    WERROR_PASSWORD_EXPIRED,
    WERROR_ACCOUNT_DISABLED,
    WERROR_NONE_MAPPED,
    WERROR_TOO_MANY_LUIDS_REQUESTED,
    WERROR_LUIDS_EXHAUSTED,
    WERROR_INVALID_SUB_AUTHORITY,
    WERROR_INVALID_ACL,
    WERROR_INVALID_SID,
    WERROR_INVALID_SECURITY_DESCR,
    WERROR_BAD_INHERITANCE_ACL                  = 1340L,
    WERROR_SERVER_DISABLED,
    WERROR_SERVER_NOT_DISABLED,
    WERROR_INVALID_ID_AUTHORITY,
    WERROR_ALLOTTED_SPACE_EXCEEDED,
    WERROR_INVALID_GROUP_ATTRIBUTES,
    WERROR_BAD_IMPERSONATION_LEVEL,
    WERROR_CANT_OPEN_ANONYMOUS,
    WERROR_BAD_VALIDATION_CLASS,
    WERROR_BAD_TOKEN_TYPE,
    WERROR_NO_SECURITY_ON_OBJECT,
    WERROR_CANT_ACCESS_DOMAIN_INFO,
    WERROR_INVALID_SERVER_STATE,
    WERROR_INVALID_DOMAIN_STATE,
    WERROR_INVALID_DOMAIN_ROLE,
    WERROR_NO_SUCH_DOMAIN,
    WERROR_DOMAIN_EXISTS,
    WERROR_DOMAIN_LIMIT_EXCEEDED,
    WERROR_INTERNAL_DB_CORRUPTION,
    WERROR_INTERNAL_ERROR,
    WERROR_GENERIC_NOT_MAPPED,
    WERROR_BAD_DESCRIPTOR_FORMAT,
    WERROR_NOT_LOGON_PROCESS,
    WERROR_LOGON_SESSION_EXISTS,
    WERROR_NO_SUCH_PACKAGE,
    WERROR_BAD_LOGON_SESSION_STATE,
    WERROR_LOGON_SESSION_COLLISION,
    WERROR_INVALID_LOGON_TYPE,
    WERROR_CANNOT_IMPERSONATE,
    WERROR_RXACT_INVALID_STATE,
    WERROR_RXACT_COMMIT_FAILURE,
    WERROR_SPECIAL_ACCOUNT,
    WERROR_SPECIAL_GROUP,
    WERROR_SPECIAL_USER,
    WERROR_MEMBERS_PRIMARY_GROUP,
    WERROR_TOKEN_ALREADY_IN_USE,
    WERROR_NO_SUCH_ALIAS,
    WERROR_MEMBER_NOT_IN_ALIAS,
    WERROR_MEMBER_IN_ALIAS,
    WERROR_ALIAS_EXISTS,
    WERROR_LOGON_NOT_GRANTED,
    WERROR_TOO_MANY_SECRETS,
    WERROR_SECRET_TOO_LONG,
    WERROR_INTERNAL_DB_ERROR,
    WERROR_TOO_MANY_CONTEXT_IDS,
    WERROR_LOGON_TYPE_NOT_GRANTED,
    WERROR_NT_CROSS_ENCRYPTION_REQUIRED,
    WERROR_NO_SUCH_MEMBER,
    WERROR_INVALID_MEMBER,
    WERROR_TOO_MANY_SIDS,
    WERROR_LM_CROSS_ENCRYPTION_REQUIRED,
    WERROR_NO_INHERITANCE,
    WERROR_FILE_CORRUPT,
    WERROR_DISK_CORRUPT,
    WERROR_NO_USER_SESSION_KEY,
    WERROR_LICENSE_QUOTA_EXCEEDED,
    WERROR_INVALID_WINDOW_HANDLE                = 1400L,
    WERROR_INVALID_MENU_HANDLE,
    WERROR_INVALID_CURSOR_HANDLE,
    WERROR_INVALID_ACCEL_HANDLE,
    WERROR_INVALID_HOOK_HANDLE,
    WERROR_INVALID_DWP_HANDLE,
    WERROR_TLW_WITH_WSCHILD,
    WERROR_CANNOT_FIND_WND_CLASS,
    WERROR_WINDOW_OF_OTHER_THREAD,
    WERROR_HOTKEY_ALREADY_REGISTERED,
    WERROR_CLASS_ALREADY_EXISTS,
    WERROR_CLASS_DOES_NOT_EXIST,
    WERROR_CLASS_HAS_WINDOWS,
    WERROR_INVALID_INDEX,
    WERROR_INVALID_ICON_HANDLE,
    WERROR_PRIVATE_DIALOG_INDEX,
    WERROR_LISTBOX_ID_NOT_FOUND,
    WERROR_NO_WILDCARD_CHARACTERS,
    WERROR_CLIPBOARD_NOT_OPEN,
    WERROR_HOTKEY_NOT_REGISTERED,
    WERROR_WINDOW_NOT_DIALOG,
    WERROR_CONTROL_ID_NOT_FOUND,
    WERROR_INVALID_COMBOBOX_MESSAGE,
    WERROR_WINDOW_NOT_COMBOBOX,
    WERROR_INVALID_EDIT_HEIGHT,
    WERROR_DC_NOT_FOUND,
    WERROR_INVALID_HOOK_FILTER,
    WERROR_INVALID_FILTER_PROC,
    WERROR_HOOK_NEEDS_HMOD,
    WERROR_GLOBAL_ONLY_HOOK,
    WERROR_JOURNAL_HOOK_SET,
    WERROR_HOOK_NOT_INSTALLED,
    WERROR_INVALID_LB_MESSAGE,
    WERROR_SETCOUNT_ON_BAD_LB,
    WERROR_LB_WITHOUT_TABSTOPS,
    WERROR_DESTROY_OBJECT_OF_OTHER_THREAD,
    WERROR_CHILD_WINDOW_MENU,
    WERROR_NO_SYSTEM_MENU,
    WERROR_INVALID_MSGBOX_STYLE,
    WERROR_INVALID_SPI_VALUE,
    WERROR_SCREEN_ALREADY_LOCKED,
    WERROR_HWNDS_HAVE_DIFF_PARENT,
    WERROR_NOT_CHILD_WINDOW,
    WERROR_INVALID_GW_COMMAND,
    WERROR_INVALID_THREAD_ID,
    WERROR_NON_MDICHILD_WINDOW,
    WERROR_POPUP_ALREADY_ACTIVE,
    WERROR_NO_SCROLLBARS,
    WERROR_INVALID_SCROLLBAR_RANGE,
    WERROR_INVALID_SHOWWIN_COMMAND,
    WERROR_NO_SYSTEM_RESOURCES,
    WERROR_NONPAGED_SYSTEM_RESOURCES,
    WERROR_PAGED_SYSTEM_RESOURCES,
    WERROR_WORKING_SET_QUOTA,
    WERROR_PAGEFILE_QUOTA,
    WERROR_COMMITMENT_LIMIT,
    WERROR_MENU_ITEM_NOT_FOUND,
    WERROR_EVENTLOG_FILE_CORRUPT                = 1500L,
    WERROR_EVENTLOG_CANT_START,
    WERROR_LOG_FILE_FULL,
    WERROR_EVENTLOG_FILE_CHANGED,
    WERROR_RPC_S_INVALID_STRING_BINDING         = 1700L,
    WERROR_RPC_S_WRONG_KIND_OF_BINDING,
    WERROR_RPC_S_INVALID_BINDING,
    WERROR_RPC_S_PROTSEQ_NOT_SUPPORTED,
    WERROR_RPC_S_INVALID_RPC_PROTSEQ,
    WERROR_RPC_S_INVALID_STRING_UUID,
    WERROR_RPC_S_INVALID_ENDPOINT_FORMAT,
    WERROR_RPC_S_INVALID_NET_ADDR,
    WERROR_RPC_S_NO_ENDPOINT_FOUND,
    WERROR_RPC_S_INVALID_TIMEOUT,
    WERROR_RPC_S_OBJECT_NOT_FOUND,
    WERROR_RPC_S_ALREADY_REGISTERED,
    WERROR_RPC_S_TYPE_ALREADY_REGISTERED,
    WERROR_RPC_S_ALREADY_LISTENING,
    WERROR_RPC_S_NO_PROTSEQS_REGISTERED,
    WERROR_RPC_S_NOT_LISTENING,
    WERROR_RPC_S_UNKNOWN_MGR_TYPE,
    WERROR_RPC_S_UNKNOWN_IF,
    WERROR_RPC_S_NO_BINDINGS,
    WERROR_RPC_S_NO_PROTSEQS,
    WERROR_RPC_S_CANT_CREATE_ENDPOINT,
    WERROR_RPC_S_OUT_OF_RESOURCES,
    WERROR_RPC_S_SERVER_UNAVAILABLE,
    WERROR_RPC_S_SERVER_TOO_BUSY,
    WERROR_RPC_S_INVALID_NETWORK_OPTIONS,
    WERROR_RPC_S_NO_CALL_ACTIVE,
    WERROR_RPC_S_CALL_FAILED,
    WERROR_RPC_S_CALL_FAILED_DNE,
    WERROR_RPC_S_PROTOCOL_ERROR,
    WERROR_RPC_S_ERROR1729,
    WERROR_RPC_S_UNSUPPORTED_TRANS_SYN,
    WERROR_RPC_S_ERROR1731,
    WERROR_RPC_S_UNSUPPORTED_TYPE,
    WERROR_RPC_S_INVALID_TAG,
    WERROR_RPC_S_INVALID_BOUND,
    WERROR_RPC_S_NO_ENTRY_NAME,
    WERROR_RPC_S_INVALID_NAME_SYNTAX,
    WERROR_RPC_S_UNSUPPORTED_NAME_SYNTAX,
    WERROR_RPC_S_ERROR1738,
    WERROR_RPC_S_UUID_NO_ADDRESS,
    WERROR_RPC_S_DUPLICATE_ENDPOINT,
    WERROR_RPC_S_UNKNOWN_AUTHN_TYPE,
    WERROR_RPC_S_MAX_CALLS_TOO_SMALL,
    WERROR_RPC_S_STRING_TOO_LONG,
    WERROR_RPC_S_PROTSEQ_NOT_FOUND,
    WERROR_RPC_S_PROCNUM_OUT_OF_RANGE,
    WERROR_RPC_S_BINDING_HAS_NO_AUTH,
    WERROR_RPC_S_UNKNOWN_AUTHN_SERVICE,
    WERROR_RPC_S_UNKNOWN_AUTHN_LEVEL,
    WERROR_RPC_S_INVALID_AUTH_IDENTITY,
    WERROR_RPC_S_UNKNOWN_AUTHZ_SERVICE,
    WERROR_EPT_S_INVALID_ENTRY,
    WERROR_EPT_S_CANT_PERFORM_OP,
    WERROR_EPT_S_NOT_REGISTERED,
    WERROR_RPC_S_NOTHING_TO_EXPORT,
    WERROR_RPC_S_INCOMPLETE_NAME,
    WERROR_RPC_S_INVALID_VERS_OPTION,
    WERROR_RPC_S_NO_MORE_MEMBERS,
    WERROR_RPC_S_NOT_ALL_OBJS_UNEXPORTED,
    WERROR_RPC_S_INTERFACE_NOT_FOUND,
    WERROR_RPC_S_ENTRY_ALREADY_EXISTS,
    WERROR_RPC_S_ENTRY_NOT_FOUND,
    WERROR_RPC_S_NAME_SERVICE_UNAVAILABLE,
    WERROR_RPC_S_INVALID_NAF_ID,
    WERROR_RPC_S_CANNOT_SUPPORT,
    WERROR_RPC_S_NO_CONTEXT_AVAILABLE,
    WERROR_RPC_S_INTERNAL_ERROR,
    WERROR_RPC_S_ZERO_DIVIDE,
    WERROR_RPC_S_ADDRESS_ERROR,
    WERROR_RPC_S_FP_DIV_ZERO,
    WERROR_RPC_S_FP_UNDERFLOW,
    WERROR_RPC_S_FP_OVERFLOW,
    WERROR_RPC_X_NO_MORE_ENTRIES,
    WERROR_RPC_X_SS_CHAR_TRANS_OPEN_FAIL,
    WERROR_RPC_X_SS_CHAR_TRANS_SHORT_FILE,
    WERROR_RPC_X_SS_IN_NULL_CONTEXT,
    WERROR_RPC_X_ERROR1776,
    WERROR_RPC_X_SS_CONTEXT_DAMAGED,
    WERROR_RPC_X_SS_HANDLES_MISMATCH,
    WERROR_RPC_X_SS_CANNOT_GET_CALL_HANDLE,
    WERROR_RPC_X_NULL_REF_POINTER,
    WERROR_RPC_X_ENUM_VALUE_OUT_OF_RANGE,
    WERROR_RPC_X_BYTE_COUNT_TOO_SMALL,
    WERROR_RPC_X_BAD_STUB_DATA,
    WERROR_INVALID_USER_BUFFER,
    WERROR_UNRECOGNIZED_MEDIA,
    WERROR_NO_TRUST_LSA_SECRET,
    WERROR_NO_TRUST_SAM_ACCOUNT,
    WERROR_TRUSTED_DOMAIN_FAILURE,
    WERROR_TRUSTED_RELATIONSHIP_FAILURE,
    WERROR_TRUST_FAILURE,
    WERROR_RPC_S_CALL_IN_PROGRESS,
    WERROR_NETLOGON_NOT_STARTED,
    WERROR_ACCOUNT_EXPIRED,
    WERROR_REDIRECTOR_HAS_OPEN_HANDLES,
    WERROR_PRINTER_DRIVER_ALREADY_INSTALLED,
    WERROR_UNKNOWN_PORT,
    WERROR_UNKNOWN_PRINTER_DRIVER,
    WERROR_UNKNOWN_PRINTPROCESSOR,
    WERROR_INVALID_SEPARATOR_FILE,
    WERROR_INVALID_PRIORITY,
    WERROR_INVALID_PRINTER_NAME,
    WERROR_PRINTER_ALREADY_EXISTS,
    WERROR_INVALID_PRINTER_COMMAND,
    WERROR_INVALID_DATATYPE,
    WERROR_INVALID_ENVIRONMENT,
    WERROR_RPC_S_NO_MORE_BINDINGS,
    WERROR_NOLOGON_INTERDOMAIN_TRUST_ACCOUNT,
    WERROR_NOLOGON_WORKSTATION_TRUST_ACCOUNT,
    WERROR_NOLOGON_SERVER_TRUST_ACCOUNT,
    WERROR_DOMAIN_TRUST_INCONSISTENT,
    WERROR_SERVER_HAS_OPEN_HANDLES,
    WERROR_RESOURCE_DATA_NOT_FOUND,
    WERROR_RESOURCE_TYPE_NOT_FOUND,
    WERROR_RESOURCE_NAME_NOT_FOUND,
    WERROR_RESOURCE_LANG_NOT_FOUND,
    WERROR_NOT_ENOUGH_QUOTA,
    WERROR_RPC_S_NO_INTERFACES,
    WERROR_RPC_S_CALL_CANCELLED,
    WERROR_RPC_S_BINDING_INCOMPLETE,
    WERROR_RPC_S_COMM_FAILURE,
    WERROR_RPC_S_UNSUPPORTED_AUTHN_LEVEL,
    WERROR_RPC_S_NO_PRINC_NAME,
    WERROR_RPC_S_NOT_RPC_ERROR,
    WERROR_RPC_S_UUID_LOCAL_ONLY,
    WERROR_RPC_S_SEC_PKG_ERROR,
    WERROR_RPC_S_NOT_CANCELLED,
    WERROR_RPC_X_INVALID_ES_ACTION,
    WERROR_RPC_X_WRONG_ES_VERSION,
    WERROR_RPC_X_WRONG_STUB_VERSION,
    WERROR_RPC_S_GROUP_MEMBER_NOT_FOUND         = 1898L,
    WERROR_EPT_S_CANT_CREATE,
    WERROR_RPC_S_INVALID_OBJECT,
    WERROR_INVALID_TIME,
    WERROR_INVALID_FORM_NAME,
    WERROR_INVALID_FORM_SIZE,
    WERROR_ALREADY_WAITING,
    WERROR_PRINTER_DELETED,
    WERROR_INVALID_PRINTER_STATE,
    WERROR_PASSWORD_MUST_CHANGE,
    WERROR_DOMAIN_CONTROLLER_NOT_FOUND,
    WERROR_ACCOUNT_LOCKED_OUT,
    WERROR_INVALID_PIXEL_FORMAT                 = 2000L,
    WERROR_BAD_DRIVER,
    WERROR_INVALID_WINDOW_STYLE,
    WERROR_METAFILE_NOT_SUPPORTED,
    WERROR_TRANSFORM_NOT_SUPPORTED,
    WERROR_CLIPPING_NOT_SUPPORTED,
    WERROR_BAD_USERNAME                         = 2202L,
    WERROR_NOT_CONNECTED                        = 2250L,
    WERROR_OPEN_FILES                           = 2401L,
    WERROR_ACTIVE_CONNECTIONS,
    WERROR_DEVICE_IN_USE                        = 2404L,
    WERROR_UNKNOWN_PRINT_MONITOR                = 3000L,
    WERROR_PRINTER_DRIVER_IN_USE,
    WERROR_SPOOL_FILE_NOT_FOUND,
    WERROR_SPL_NO_STARTDOC,
    WERROR_SPL_NO_ADDJOB,
    WERROR_PRINT_PROCESSOR_ALREADY_INSTALLED,
    WERROR_PRINT_MONITOR_ALREADY_INSTALLED,
    WERROR_WINS_INTERNAL                        = 4000L,
    WERROR_CAN_NOT_DEL_LOCAL_WINS,
    WERROR_STATIC_INIT,
    WERROR_INC_BACKUP,
    WERROR_FULL_BACKUP,
    WERROR_REC_NON_EXISTENT,
    WERROR_RPL_NOT_ALLOWED,
    WERROR_NO_BROWSER_SERVERS_FOUND             = 6118L,
    WERROR_UNKNOWN                              = 0x2FFFFFFFL,
};

typedef struct WErrorStruct {
    WULong                      errorCode;
    WString                     message;
} WErrorStruct;

/*************************************************************************
 *
 * WError -- Base Error class
 *
 *   Events:
 *
 *************************************************************************/

class WCMCLASS WError {
    WDeclareName( WError );

    public:

        /**************************************************************
         * Constructors and destructors
         **************************************************************/
    
        WError();

        virtual ~WError();

        /**************************************************************
         * Static Properties
         **************************************************************/

        // ErrorLogFile

        static void  SetErrorLogFile( const char * fileName );

        // LastError

        static void SetLastError( WULong errorCode );
        static WULong GetLastError();
        static void GetLastError( WErrorStruct & error );

        /**************************************************************
         * Static Methods
         **************************************************************/

        // IsError

        static WBool IsError();

        // UpdateErrorLogFile

        static void UpdateErrorLogFile( const WChar * file, WLong line );

        /**************************************************************
         * Others
         **************************************************************/
};

#ifndef _WNO_PRAGMA_PUSH
#pragma enum pop;
#pragma pack(pop);
#endif

#endif // _WERROR_HPP_INCLUDED
