//
// weventd.hpp
//

#ifndef _WEVENTD_HPP_INCLUDED
#define _WEVENTD_HPP_INCLUDED

    #ifndef _WNO_PRAGMA_PUSH
    #pragma pack(push,8);
    #pragma enum int;
    #endif
    
    #ifndef _WEVENT_HPP_INCLUDED
    #  include "wevent.hpp"
    #endif
    #ifndef _WPOINT_HPP_INCLUDED
    #  include "wpoint.hpp"
    #endif

    /* Event structure -- this is the common structure everyone
       must use */

    struct WCMCLASS WEventData {
        WObject *       eventObject;     // object that generated event
        WEventHandler   eventHandler;    // current event handler
        WEventID        eventID;         // type of event
        WLong           returns;         // the return value
        void *          userData;        // per-event userdata
        WInt            handlerIndex;    // the index of this event handler
    };

    //
    // Create event
    //

    struct WCMCLASS WCreateEventData : public WEventData {
        WULong          createData;    // data from lParam
        WBool           isDialog;      // TRUE if a dialog
        WWindowHandle   focusWindow;   // for dialogs only -- user can change
    };

#ifndef _WNO_PRAGMA_PUSH
#pragma enum pop;
#pragma pack(pop);
#endif

#endif
