/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1994, by WATCOM International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of WATCOM International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*/

#ifndef _WKEYDEFS_HPP_INCLUDED
#define _WKEYDEFS_HPP_INCLUDED

#ifndef _WNO_PRAGMA_PUSH
#pragma pack(push,8);
#pragma enum int;
#endif

enum WKeyStateValues {
    WKNullState         = 0x00,
    WKShiftPressed      = 0x01<<0,
    WKControlPressed    = 0x01<<1,
    WKAltPressed        = 0x01<<2,
    WKLeftMousePressed  = 0x01<<3,
    WKMiddleMousePressed= 0x01<<4,
    WKRightMousePressed = 0x01<<5,
};
typedef WULong WKeyState;

enum WKeyPressCode {
    WKeyNone                    = 0x00,
    WKeyLeftMouseButton         = 0x01,
    WKeyRightMouseButton        = 0x02,
    WKeyCancel                  = 0x03,
    WKeyMiddleMouseButton       = 0x04,
    WKeyBackspace               = 0x08,
    WKeyTab                     = 0x09,
    WKeyClear                   = 0x0C,
    WKeyReturn                  = 0x0D,
    WKeyShift                   = 0x10,
    WKeyControl                 = 0x11,
    WKeyAlt                     = 0x12,
    WKeyPause                   = 0x13,
    WKeyCapsLock                = 0x14,
    WKeyEscape                  = 0x1B,
    WKeySpace                   = 0x20,

    WKeyPageUp                  = 0x21,
    WKeyPageDn                  = 0x22,         WKeyPageDown = WKeyPageDn,
    WKeyEnd                     = 0x23,
    WKeyHome                    = 0x24,
    WKeyLeft                    = 0x25,
    WKeyUp                      = 0x26,
    WKeyRight                   = 0x27,
    WKeyDown                    = 0x28,

    WKeySelect                  = 0x29,
    WKeyPrint                   = 0x2A,
    WKeyExecute                 = 0x2B,
    WKeyPrintScreen             = 0x2C,

    WKeyInsert                  = 0x2D,
    WKeyDelete                  = 0x2E,
    WKeyHelp                    = 0x2F,

    WKey0                       = '0',
    WKey1                       = '1',
    WKey2                       = '2',
    WKey3                       = '3',
    WKey4                       = '4',
    WKey5                       = '5',
    WKey6                       = '6',
    WKey7                       = '7',
    WKey8                       = '8',
    WKey9                       = '9',

    WKeyA                       = 'A',
    WKeyB                       = 'B',
    WKeyC                       = 'C',
    WKeyD                       = 'D',
    WKeyE                       = 'E',
    WKeyF                       = 'F',
    WKeyG                       = 'G',
    WKeyH                       = 'H',
    WKeyI                       = 'I',
    WKeyJ                       = 'J',
    WKeyK                       = 'K',
    WKeyL                       = 'L',
    WKeyM                       = 'M',
    WKeyN                       = 'N',
    WKeyO                       = 'O',
    WKeyP                       = 'P',
    WKeyQ                       = 'Q',
    WKeyR                       = 'R',
    WKeyS                       = 'S',
    WKeyT                       = 'T',
    WKeyU                       = 'U',
    WKeyV                       = 'V',
    WKeyW                       = 'W',
    WKeyX                       = 'X',
    WKeyY                       = 'Y',
    WKeyZ                       = 'Z',

    WKeyNumpad0                 = 0x60,
    WKeyNumpad1                 = 0x61,
    WKeyNumpad2                 = 0x62,
    WKeyNumpad3                 = 0x63,
    WKeyNumpad4                 = 0x64,
    WKeyNumpad5                 = 0x65,
    WKeyNumpad6                 = 0x66,
    WKeyNumpad7                 = 0x67,
    WKeyNumpad8                 = 0x68,
    WKeyNumpad9                 = 0x69,

    WKeyStar                    = 0x6A,
    WKeyPlus                    = 0x6B,
    WKeySeparator               = 0x6C,
    WKeyMinus                   = 0x6D,
    WKeyDecimal                 = 0x6E,
    WKeyDivide                  = 0x6F,

    WKeyF1                      = 0x70,
    WKeyF2                      = 0x71,
    WKeyF3                      = 0x72,
    WKeyF4                      = 0x73,
    WKeyF5                      = 0x74,
    WKeyF6                      = 0x75,
    WKeyF7                      = 0x76,
    WKeyF8                      = 0x77,
    WKeyF9                      = 0x78,
    WKeyF10                     = 0x79,
    WKeyF11                     = 0x7A,
    WKeyF12                     = 0x7B,
    WKeyF13                     = 0x7C,
    WKeyF14                     = 0x7D,
    WKeyF15                     = 0x7E,
    WKeyF16                     = 0x7F,
    WKeyF17                     = 0x80,
    WKeyF18                     = 0x81,
    WKeyF19                     = 0x82,
    WKeyF20                     = 0x83,
    WKeyF21                     = 0x84,
    WKeyF22                     = 0x85,
    WKeyF23                     = 0x86,
    WKeyF24                     = 0x87,

    WKeyNumLock                 = 0x90,
    WKeyScroll                  = 0x91,
};

struct WKeyMessage {
    WKeyState           state;
    WBool               prevDown;
    WBool               keyDown;
    WUInt               scanCode;
    WUInt               repeatCount;
};

#ifndef _WNO_PRAGMA_PUSH
#pragma enum pop;
#pragma pack(pop);
#endif

#endif // _WKEYDEFS_HPP_INCLUDED
