/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1994, by WATCOM International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of WATCOM International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*/

/*************************************************************************
 *
 * WMessageID --
 *
 *************************************************************************/

#ifndef _WMSGID_HPP_INCLUDED
#define _WMSGID_HPP_INCLUDED

#ifndef _WNO_PRAGMA_PUSH
#pragma pack(push,8);
#pragma enum int;
#endif

#ifndef _WOBJECT_HPP_INCLUDED
#  include "wobject.hpp"
#endif
#ifndef _WARRAY_HPP_INCLUDED
#  include "warray.hpp"
#endif

#define WMakeLangID(p, s)       ((((WUShort  )(s)) << 10) | (WUShort  )(p))
#define WPrimaryLangID(lgid)    ((WUShort)(lgid) & 0x3ff)
#define WSubLangID(lgid)        ((WUShort)(lgid) >> 10)

// when passign a parameter for the Language ID you must use WMakeLangID
// using a primary language and a sublanguage
// primary languages

#define WLANG_NEUTRAL                     0x00

#define WLANG_ARABIC                      0x01
#define WLANG_AFRIKAANS                   0x36
#define WLANG_ALBANIAN                    0x1c
#define WLANG_BASQUE                      0x2d
#define WLANG_BULGARIAN                   0x02
#define WLANG_BYELORUSSIAN                0x23
#define WLANG_CATALAN                     0x03
#define WLANG_CHINESE                     0x04
#define WLANG_CROATIAN                    0x1a
#define WLANG_CZECH                       0x05
#define WLANG_DANISH                      0x06
#define WLANG_DUTCH                       0x13
#define WLANG_ENGLISH                     0x09
#define WLANG_ESTONIAN                    0x25
#define WLANG_FAEROESE                    0x38
#define WLANG_FARSI                       0x29
#define WLANG_FINNISH                     0x0b
#define WLANG_FRENCH                      0x0c
#define WLANG_GERMAN                      0x07
#define WLANG_GREEK                       0x08
#define WLANG_HEBREW                      0x0D
#define WLANG_HUNGARIAN                   0x0e
#define WLANG_ICELANDIC                   0x0f
#define WLANG_INDONESIAN                  0x21
#define WLANG_ITALIAN                     0x10
#define WLANG_JAPANESE                    0x11
#define WLANG_KOREAN                      0x12
#define WLANG_LATVIAN                     0x26
#define WLANG_LITHUANIAN                  0x27
#define WLANG_NORWEGIAN                   0x14
#define WLANG_POLISH                      0x15
#define WLANG_PORTUGUESE                  0x16
#define WLANG_ROMANIAN                    0x18
#define WLANG_RUSSIAN                     0x19
#define WLANG_SLOVAK                      0x1b
#define WLANG_SLOVENIAN                   0x24
#define WLANG_SORBIAN                     0x2e
#define WLANG_SPANISH                     0x0a
#define WLANG_SWEDISH                     0x1d
#define WLANG_THAI                        0x1e
#define WLANG_TURKISH                     0x1f
#define WLANG_UKRAINIAN                   0x22

// sublanguage IDs

#define WSUBLANG_NEUTRAL                  0x00    /* language neutral */
#define WSUBLANG_DEFAULT                  0x01    /* user default */
#define WSUBLANG_SYS_DEFAULT              0x02    /* system default */

#define WSUBLANG_ARABIC                   0x01    /* Arabic (Saudi Arabia) */
#define WSUBLANG_ARABIC_IRAQ              0x02    /* Arabic (Iraq) */
#define WSUBLANG_ARABIC_EGYPT             0x03    /* Arabic (Egypt) */
#define WSUBLANG_ARABIC_LIBYA             0x04    /* Arabic (Libya) */
#define WSUBLANG_ARABIC_ALGERIA           0x05    /* Arabic (Algeria) */
#define WSUBLANG_ARABIC_MOROCCO           0x06    /* Arabic (Morocco) */
#define WSUBLANG_ARABIC_TUNISIA           0x07    /* Arabic (Tunisia) */
#define WSUBLANG_ARABIC_OMAN              0x08    /* Arabic (Oman) */
#define WSUBLANG_ARABIC_YEMEN             0x09    /* Arabic (Yemen) */
#define WSUBLANG_ARABIC_SYRIA             0x10    /* Arabic (Syria) */
#define WSUBLANG_ARABIC_JORDAN            0x11    /* Arabic (Jordan) */
#define WSUBLANG_ARABIC_LEBANON           0x12    /* Arabic (Lebanon) */
#define WSUBLANG_ARABIC_KUWAIT            0x13    /* Arabic (Kuwait) */
#define WSUBLANG_ARABIC_UAE               0x14    /* Arabic (United Arab Emirates) */
#define WSUBLANG_ARABIC_BAHRAIN           0x15    /* Arabic (Bahrain) */
#define WSUBLANG_ARABIC_QATAR             0x16    /* Arabic (Qatar) */
#define WSUBLANG_CHINESE_TRADITIONAL      0x01    /* Chinese (Taiwan) */
#define WSUBLANG_CHINESE_SIMPLIFIED       0x02    /* Chinese (PR China) */
#define WSUBLANG_CHINESE_HONGKONG         0x03    /* Chinese (Hong Kong) */
#define WSUBLANG_CHINESE_SINGAPORE        0x04    /* Chinese (Singapore) */
#define WSUBLANG_DUTCH                    0x01    /* Dutch */
#define WSUBLANG_DUTCH_BELGIAN            0x02    /* Dutch (Belgian) */
#define WSUBLANG_ENGLISH_US               0x01    /* English (USA) */
#define WSUBLANG_ENGLISH_UK               0x02    /* English (UK) */
#define WSUBLANG_ENGLISH_AUS              0x03    /* English (Australian) */
#define WSUBLANG_ENGLISH_CAN              0x04    /* English (Canadian) */
#define WSUBLANG_ENGLISH_NZ               0x05    /* English (New Zealand) */
#define WSUBLANG_ENGLISH_EIRE             0x06    /* English (Irish) */
#define WSUBLANG_ENGLISH_SAFRICA          0x07    /* English (South Africa) */
#define WSUBLANG_ENGLISH_JAMAICA          0x08    /* English (Jamaica) */
#define WSUBLANG_ENGLISH_CARRIBEAN        0x09    /* English (Carribean) */
#define WSUBLANG_FRENCH                   0x01    /* French */
#define WSUBLANG_FRENCH_BELGIAN           0x02    /* French (Belgian) */
#define WSUBLANG_FRENCH_CANADIAN          0x03    /* French (Canadian) */
#define WSUBLANG_FRENCH_SWISS             0x04    /* French (Swiss) */
#define WSUBLANG_FRENCH_LUXEMBOURG        0x05    /* French (Luxembourg) */
#define WSUBLANG_GERMAN                   0x01    /* German */
#define WSUBLANG_GERMAN_SWISS             0x02    /* German (Swiss) */
#define WSUBLANG_GERMAN_AUSTRIAN          0x03    /* German (Austrian) */
#define WSUBLANG_GERMAN_LUXEMBOURG        0x04    /* German (Luxembourg) */
#define WSUBLANG_GERMAN_LIECHTENSTEIN     0x05    /* German (Liechtenstein) */
#define WSUBLANG_ITALIAN                  0x01    /* Italian */
#define WSUBLANG_ITALIAN_SWISS            0x02    /* Italian (Swiss) */
#define WSUBLANG_KOREAN                   0x01    /* Korean */
#define WSUBLANG_KOREAN_JOHAB             0x02    /* Korean (Johab) */
#define WSUBLANG_NORWEGIAN_BOKMAL         0x01    /* Norwegian (Bokmal) */
#define WSUBLANG_NORWEGIAN_NYNORSK        0x02    /* Norwegian (Nynorsk) */
#define WSUBLANG_PORTUGUESE               0x02    /* Portuguese */
#define WSUBLANG_PORTUGUESE_BRAZILIAN     0x01    /* Portuguese (Brazilian) */
#define WSUBLANG_SPANISH                  0x01    /* Spanish (Castilian) */
#define WSUBLANG_SPANISH_MEXICAN          0x02    /* Spanish (Mexican) */
#define WSUBLANG_SPANISH_MODERN           0x03    /* Spanish (Modern) */
#define WSUBLANG_SPANISH_GUATEMALA        0x04    /* Spanish (Guatemala) */
#define WSUBLANG_SPANISH_COSTARICA        0x05    /* Spanish (Costa Rica) */
#define WSUBLANG_SPANISH_PANAMA           0x06    /* Spanish (Panama) */
#define WSUBLANG_SPANISH_DOMINICAN        0x07    /* Spanish (Dominican Republic) */
#define WSUBLANG_SPANISH_VENEZUELA        0x08    /* Spanish (Venezuela) */
#define WSUBLANG_SPANISH_COLOMBIA         0x09    /* Spanish (Colombia) */
#define WSUBLANG_SPANISH_PERU             0x10    /* Spanish (Peru) */
#define WSUBLANG_SPANISH_ARGENTINA        0x11    /* Spanish (Argentina) */
#define WSUBLANG_SPANISH_ECUADOR          0x12    /* Spanish (Ecuador) */
#define WSUBLANG_SPANISH_CHILE            0x13    /* Spanish (Chile) */
#define WSUBLANG_SPANISH_URUGUAY          0x14    /* Spanish (Uruguay) */
#define WSUBLANG_SPANISH_PARAGUAY         0x15    /* Spanish (Paraguay) */
#define WSUBLANG_SPANISH_BOLIVIA          0x16    /* Spanish (Bolivia) */

// Default system and user ids for language

#define WLANG_SYSTEM_DEFAULT    (WMakeLangID(WLANG_NEUTRAL, WSUBLANG_SYS_DEFAULT))
#define WLANG_USER_DEFAULT      (WMakeLangID(WLANG_NEUTRAL, WSUBLANG_DEFAULT))



class WCMCLASS WMessageID : public WObject {
    WDeclareSubclass( WMessageID, WObject );

    public:

        /*********************************************************
         * Constructors and destructors
         *********************************************************/

        WMessageID( WULong id, WULong langid );
        WMessageID( const WMessageID & id );

        ~WMessageID();

        /*********************************************************
         * Properties
         *********************************************************/

        // ID

        WULong GetID() const;

        // LangID

        WULong GetLangID() const;

        /*********************************************************
         * Methods
         *********************************************************/

        // Create

        WBool Create( WULong number, WULong language );
        WBool Create( const WMessageID & id );

        /*********************************************************
         * Operators
         *********************************************************/

        WMessageID & operator=( const WMessageID & msgId )
            { Create( msgId ); return *this; }

        WMessageID & operator=( const WULong id )
            { Create( id, WLANG_SYSTEM_DEFAULT ); return *this; }


        /*********************************************************
         * Data members
         *********************************************************/

    private:
        WULong  _msgID;
        WULong  _langID;
};

extern template WArrayReference<WMessageID>;
extern template WArray<WMessageID>;
typedef WArray<WMessageID>      WMessageIDArray;

#ifndef _WNO_PRAGMA_PUSH
#pragma enum pop;
#pragma pack(pop);
#endif

#endif // _WRESID_HPP_INCLUDED
