#ifndef _WOAPPLIC_HPP_INCLUDED
#define _WOAPPLIC_HPP_INCLUDED

#ifndef _WNO_PRAGMA_PUSH
#pragma pack(push,8);
#pragma enum int;
#endif

#ifndef _WOLE_HPP_INCLUDED
#  include "woletype.hpp"
#endif
#ifndef _WAPPLIC_HPP_INCLUDED
#  include "wapplic.hpp"
#endif

// forward class declarations
class WOleClassManager;

/********************************************************************
 *
 * WOleDLLApplication -- OLE DLL Application class
 *
 *
 *   Events:
 *
 ********************************************************************/

class WCMCLASS WOleDLLApplication : public WDLLApplication {
    WDeclareSubclass( WOleDLLApplication, WDLLApplication );

    public:

        /**********************************************************
         * Constructors and Destructors
         *********************************************************/

        WOleDLLApplication();

        ~WOleDLLApplication();

    public:

        /**************************************************************
         * Properties
         **************************************************************/

        // the Class Manager
        WOleClassManager *GetClassManager( void ) const;

        /**************************************************************
         * Methods
         **************************************************************/

        WULong DllRegisterServer( void );
        WULong DllUnregisterServer( void );
        WULong DllGetClassObject( const WCLSID & rclsid, const WIID & riid, void **ppv );
        WULong DllCanUnloadNow( void );

    /**********************************************************
     * Data Members
     *********************************************************/
    
        WOleClassManager        *_classManager;
};

/********************************************************************
 *
 * WOleEXEApplication -- OLE EXE Application class
 *
 *
 *   Events:
 *
 ********************************************************************/

class WCMCLASS WOleExeApplication : public WExeApplication {
    WDeclareSubclass( WOleExeApplication, WExeApplication );

    public:

        /**********************************************************
         * Constructors and Destructors
         *********************************************************/

        WOleExeApplication();

        ~WOleExeApplication();

    public:

        /**************************************************************
         * Properties
         **************************************************************/

        // User Mode
        WBool SetUserMode( WBool userMode );
        WBool GetUserMode( void ) const;

        // Allow User Mode
        WBool SetAllowUserMode( WBool allowUserMode );
        WBool GetAllowUserMode( void ) const;

        // the Class Manager
        WOleClassManager *GetClassManager( void ) const;

        /**************************************************************
         * Methods
         **************************************************************/

        WULong ExeRegisterServer( void );
        WULong ExeUnregisterServer( void );
        WULong ExeRegisterClassObjects( void );
        WULong ExeRevokeClassObjects( void );

        int EntryPoint( unsigned int inst, unsigned int prev,
                        const WAnsiChar *command, int show );

    /**********************************************************
     * Data Members
     *********************************************************/
    
        WOleClassManager        *_classManager;
        WBool                   _allowUserMode;
};

#ifndef _WNO_PRAGMA_PUSH
#pragma enum pop;
#pragma pack(pop);
#endif

#endif // _WOAPPLIC_HPP_INCLUDED
