/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1994, by WATCOM International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of WATCOM International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*/

#ifndef _WOLE_HPP_INCLUDED
#define _WOLE_HPP_INCLUDED

#ifndef _WNO_PRAGMA_PUSH
#pragma pack(push,4);
#pragma enum int;
#endif

// **** ************************************************
// **** The following are very temporary measures !!!!!
// **** ************************************************

// *****************************************************
// * Define Windows base types and macros
// * If you wish to use windows.h you MUST include
// * it before this file
// *****************************************************

// from rpc.h
#ifndef __RPC_H__
#define __RPC_H__

#define __RPC_FAR

#endif // __RPC_H__

// from wtypes.h
#ifndef __wtypes_h__
#define __wtypes_h__

#ifndef _BYTE_DEFINED
#define _BYTE_DEFINED
typedef unsigned char BYTE;
#endif // !_BYTE_DEFINED

#ifndef _WORD_DEFINED
#define _WORD_DEFINED
typedef unsigned short WORD;
#endif // !_WORD_DEFINED

typedef /* [transmit] */ unsigned int UINT;

typedef /* [transmit] */ int INT;

#ifndef _LONG_DEFINED
#define _LONG_DEFINED
typedef long LONG;
#endif // !_LONG_DEFINED

#ifndef _DWORD_DEFINED
#define _DWORD_DEFINED
typedef unsigned long DWORD;
#endif // !_DWORD_DEFINED

typedef DWORD ULONG;

typedef LONG SCODE;

typedef LONG HRESULT;

#ifndef _WCHAR_T_DEFINED
typedef unsigned short wchar_t;
#define _WCHAR_T_DEFINED
#endif

#ifndef _WCHAR_DEFINED
#define _WCHAR_DEFINED
typedef wchar_t WCHAR;
typedef WCHAR TCHAR;
#endif // !_WCHAR_DEFINED

typedef WCHAR OLECHAR;
typedef /* [string] */ OLECHAR __RPC_FAR *LPOLESTR;
typedef /* [string] */ const OLECHAR __RPC_FAR *LPCOLESTR;
#define OLESTR(str) L##str

#ifndef GUID_DEFINED
#define GUID_DEFINED
                        /* size is 16 */
typedef struct  _GUID
    {
    DWORD Data1;
    WORD Data2;
    WORD Data3;
    BYTE Data4[ 8 ];
    }   GUID;

#endif // !GUID_DEFINED

#if !defined( __IID_DEFINED__ )
#define __IID_DEFINED__

typedef GUID IID;
#define IID_NULL            GUID_NULL
typedef GUID CLSID;
#define CLSID_NULL          GUID_NULL

#ifndef _REFGUID_DEFINED
#define _REFGUID_DEFINED
#define REFGUID             const GUID &
#endif // !_REFGUID_DEFINED
#ifndef _REFIID_DEFINED
#define _REFIID_DEFINED
#define REFIID              const IID &
#endif // !_REFIID_DEFINED
#ifndef _REFCLSID_DEFINED
#define _REFCLSID_DEFINED
#define REFCLSID            const CLSID &
#endif // !_REFCLSID_DEFINED

#endif // !__IID_DEFINED__

#ifndef _LCID_DEFINED
#define _LCID_DEFINED
typedef DWORD LCID;
#endif // !_LCID_DEFINED

#endif

// *****************************************************
// * Define OLE base types and macros
// *****************************************************

// from basetyps.h
#if !defined( _BASETYPS_H_ )
#define _BASETYPS_H_

#define interface struct

#endif

// *****************************************************
// * Define OLE specific types and macros
// *****************************************************

// from objbase.h
#if !defined( _OBJBASE_H_ )
#define _OBJBASE_H_

#ifndef __IUnknown_FWD_DEFINED__
#define __IUnknown_FWD_DEFINED__
typedef interface IUnknown IUnknown;
#endif  /* __IUnknown_FWD_DEFINED__ */

#ifndef __IUnknown_INTERFACE_DEFINED__
#define __IUnknown_INTERFACE_DEFINED__

typedef /* [unique] */ IUnknown __RPC_FAR *LPUNKNOWN;

    interface IUnknown
    {
    public:
        virtual HRESULT __stdcall QueryInterface( 
            /* [in] */ REFIID riid,
            /* [out] */ void __RPC_FAR *__RPC_FAR *ppvObject) = 0;
        
        virtual ULONG __stdcall AddRef( void) = 0;
        
        virtual ULONG __stdcall Release( void) = 0;
        
    };
    

#endif  /* __IUnknown_INTERFACE_DEFINED__ */

#endif     // __objbase_H__

// *****************************************************
// * Define OLE Automation specific types and macros
// *****************************************************

// from oleauto.h
#ifndef _OLEAUTO_H_
#define _OLEAUTO_H_

#ifndef _DISPID_DEFINED
#define _DISPID_DEFINED
typedef LONG DISPID;
#endif

typedef OLECHAR __RPC_FAR *BSTR;

typedef struct tagVARIANT VARIANT;

#ifndef _VARIANTARG_DEFINED
#define _VARIANTARG_DEFINED
                        /* size is 16 */
typedef struct tagVARIANT VARIANTARG;

#endif
typedef struct  tagDISPPARAMS
    {
    /* [size_is] */ VARIANTARG __RPC_FAR *rgvarg;
    /* [size_is] */ DISPID __RPC_FAR *rgdispidNamedArgs;
    UINT cArgs;
    UINT cNamedArgs;
    }   DISPPARAMS;

#ifndef __ITypeInfo_FWD_DEFINED__
#define __ITypeInfo_FWD_DEFINED__
typedef interface ITypeInfo ITypeInfo;
#endif  /* __ITypeInfo_FWD_DEFINED__ */

#ifndef __IDispatch_FWD_DEFINED__
#define __IDispatch_FWD_DEFINED__
typedef interface IDispatch IDispatch;
#endif  /* __IDispatch_FWD_DEFINED__ */

#ifndef _tagEXCEPINFO_DEFINED
#define _tagEXCEPINFO_DEFINED
#define _EXCEPINFO_DEFINED
#define _LPEXCEPINFO_DEFINED
                        /* size is 32 */
typedef /* [transmit] */ struct  tagEXCEPINFO
    {
    WORD wCode;
    WORD wReserved;
    BSTR bstrSource;
    BSTR bstrDescription;
    BSTR bstrHelpFile;
    DWORD dwHelpContext;
    /* [unique] */ void __RPC_FAR *pvReserved;
    HRESULT ( __RPC_FAR *pfnDeferredFillIn )( 
        struct tagEXCEPINFO __RPC_FAR *__MIDL_0004);
    SCODE scode;
    }   EXCEPINFO;

                        /* size is 4 */
typedef /* [transmit] */ struct tagEXCEPINFO __RPC_FAR *LPEXCEPINFO;

#endif

#ifndef __IDispatch_INTERFACE_DEFINED__
#define __IDispatch_INTERFACE_DEFINED__

typedef /* [unique] */ IDispatch __RPC_FAR *LPDISPATCH;

    interface IDispatch : public IUnknown
    {
    public:
        virtual HRESULT __stdcall GetTypeInfoCount( 
            /* [out] */ UINT __RPC_FAR *pctinfo) = 0;
        
        virtual HRESULT __stdcall GetTypeInfo( 
            /* [in] */ UINT itinfo,
            /* [in] */ LCID lcid,
            /* [out] */ ITypeInfo __RPC_FAR *__RPC_FAR *pptinfo) = 0;
        
        virtual HRESULT __stdcall GetIDsOfNames( 
            /* [in] */ REFIID riid,
            /* [size_is][in] */ LPOLESTR __RPC_FAR *rgszNames,
            /* [in] */ UINT cNames,
            /* [in] */ LCID lcid,
            /* [size_is][out][in] */ DISPID __RPC_FAR *rgdispid) = 0;
        
        virtual HRESULT __stdcall Invoke( 
            /* [in] */ DISPID dispidMember,
            /* [in] */ REFIID riid,
            /* [in] */ LCID lcid,
            /* [in] */ WORD wFlags,
            /* [unique][in] */ DISPPARAMS __RPC_FAR *pdispparams,
            /* [unique][out][in] */ VARIANT __RPC_FAR *pvarResult,
            /* [out] */ EXCEPINFO __RPC_FAR *pexcepinfo,
            /* [out] */ UINT __RPC_FAR *puArgErr) = 0;
        
    };
    
#endif  /* __IDispatch_INTERFACE_DEFINED__ */

#endif // _OLEAUTO_H_

#ifndef _WNO_PRAGMA_PUSH
#pragma enum pop;
#pragma pack(pop);
#endif

#endif // _WOLE_HPP_INCLUDED
