/*************************************************************************
 *
 * WOleApplicationObject -- OLE Application Object class
 *
 *
 *   Events:
 *
 *
 *************************************************************************/

#ifndef _WOLEAOBJ_HPP_INCLUDED
#define _WOLEAOBJ_HPP_INCLUDED

#ifndef _WNO_PRAGMA_PUSH
#pragma pack(push,8);
#pragma enum int;
#endif

#ifndef _WOBJECT_HPP_INCLUDED
#  include "wobject.hpp"
#endif
#ifndef _WSTRING_HPP_INCLUDED
#  include "wstring.hpp"
#endif

// forward class declarations
class WCMCLASS WIMessageFilter;
class WCMCLASS WWindow;

class WCMCLASS WOleApplicationObject : public WObject {
    WDeclareSubclass( WOleApplicationObject, WObject );

    public:

        /**********************************************************
         * Constructors and Destructors
         *********************************************************/

        WOleApplicationObject( void );

        virtual ~WOleApplicationObject();

        /**************************************************************
         * Properties
         **************************************************************/

        WBool SetShowAutomationErrors( WBool set );
        WBool GetShowAutomationErrors( void ) const;

        WBool SetUseServerBusyDialog( WBool set );
        WBool GetUseServerBusyDialog( void ) const;

        WBool SetUseNotRespondingDialog( WBool set );
        WBool GetUseNotRespondingDialog( void ) const;

        WBool SetApplicationWindow( WWindow * win );
        WWindow *GetApplicationWindow( void ) const;

        WBool SetServerBusyTimeout( WUInt timeout );
        WUInt GetServerBusyTimeout( void ) const;

        WBool SetNotRespondingTimeout( WUInt timeout );
        WUInt GetNotRespondingTimeout( void ) const;

        WWindowHandle GetBusyDialogHandle( void ) const;

        static WOleApplicationObject * GetOleApplicationObject( void );
        static WBool OleApplicationInitialize( void );
        static WBool OleApplicationUnInitialize( void );

        /**************************************************************
         * Methods
         **************************************************************/

        /**************************************************************
         * Internal Methods
         **************************************************************/

        WBool Initialize( void );
        WBool Uninitialize( void );

    protected:

        WBool InitMessageFilter( void );
        void FiniMessageFilter( void );

        /**********************************************************
         * Data Members
         *********************************************************/
    
    protected:
        WBool           _showAutomationErrors;

    public:
        WIMessageFilter *_pIMessageFilter;

};

#ifndef _WNO_PRAGMA_PUSH
#pragma enum pop;
#pragma pack(pop);
#endif

#endif // _WOLEAOBJ_HPP_INCLUDED

