/*************************************************************************
 *
 * WBString -- OLE BString
 *
 *
 *   Events:
 *
 *
 *************************************************************************/

#ifndef _WOLEBSTR_HPP_INCLUDED
#define _WOLEBSTR_HPP_INCLUDED

#ifndef _WNO_PRAGMA_PUSH
#pragma pack(push,8);
#pragma enum int;
#endif

#ifndef _WSTRING_HPP_INCLUDED
#  include "wstring.hpp"
#endif
#ifndef _WBUFFER_HPP_INCLUDED
#  include "wbuffer.hpp"
#endif

#ifndef _WOLETYPE_HPP_INCLUDED
#  include "woletype.hpp"
#endif
//typedef long char * WBStr;

class WCMCLASS WBString {

    public:

        /**********************************************************
         * Constructors and Destructors
         *********************************************************/

        WBString( void );
        WBString( const WChar * const str );
        WBString( WBStr wbstr );
        WBString( const WString & wstring );
        WBString( const WBuffer & buffer );
        WBString( const WBString & wbstr );
        WBString( WULong size, WUnicodeChar *buffer );

        virtual ~WBString();

        /**************************************************************
         * Properties
         **************************************************************/

        WUInt GetLength( void ) const;
        WUInt GetByteLength( void ) const;

        // Handle
        WBStr GetHandle( void ) const;
        WBool SetHandle( WBStr wbstr );

        /**************************************************************
         * Methods
         **************************************************************/

        void Clear( void );

        WBStr CopyHandle( void ) const;

        static void FreeString( WBStr bstr );

        /**************************************************************
         * Operators
         **************************************************************/

        WBString & operator=( const WBString & bstr );
        WBString & operator=( WBStr wbstr );

        // cast operators
        operator WString() const;
        operator WBuffer() const;
        operator WBStr() const;

    public:

        /**********************************************************
         * Data Members
         *********************************************************/
    
        WBStr   _bstring;

};

#ifndef _WNO_PRAGMA_PUSH
#pragma enum pop;
#pragma pack(pop);
#endif

#endif // _WOLEBSTR_HPP_INCLUDED

