/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1994, by WATCOM International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of WATCOM International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*/

#ifndef _WOLECTL_HPP_INCLUDED
#define _WOLECTL_HPP_INCLUDED

#ifndef _WNO_PRAGMA_PUSH
#pragma pack(push,4);
#pragma enum int;
#endif

#include "wole.hpp"

// *****************************************************
// * Define OLE Control specific types and macros
// *****************************************************
#ifndef _OLECTL_H_

// forward declarations
struct IFont;
struct IFontDisp;
struct IPicture;
struct IPictureDisp;

typedef IFont * LPFONT;
typedef IFontDisp * LPFONTDISP;
typedef IPicture * LPPICTURE;
typedef IPictureDisp * LPPICTUREDISP;

// Typedefs for standard scalar types
typedef unsigned long OLE_COLOR;
typedef long OLE_XPOS_PIXELS;
typedef long OLE_YPOS_PIXELS;
typedef long OLE_XSIZE_PIXELS;
typedef long OLE_YSIZE_PIXELS;
typedef long OLE_XPOS_HIMETRIC;
typedef long OLE_YPOS_HIMETRIC;
typedef long OLE_XSIZE_HIMETRIC;
typedef long OLE_YSIZE_HIMETRIC;
typedef float OLE_XPOS_CONTAINER;
typedef float OLE_YPOS_CONTAINER;
typedef float OLE_XSIZE_CONTAINER;
typedef float OLE_YSIZE_CONTAINER;
typedef enum { triUnchecked = 0, triChecked = 1, triGray = 2 } OLE_TRISTATE;
typedef unsigned int OLE_OPTEXCLUSIVE;
typedef unsigned int OLE_CANCELBOOL;
typedef unsigned int OLE_ENABLEDEFAULTBOOL;
typedef unsigned int OLE_HANDLE;

#endif // _OLECTL_H_

#ifndef _WNO_PRAGMA_PUSH
#pragma enum pop;
#pragma pack(pop);
#endif

#endif // _WOLECTL_HPP_INCLUDED
