
/*************************************************************************
 *
 * WPrinterData
 *
 *************************************************************************/

#ifndef _WPRTDATA_HPP_INCLUDED
#define _WPRTDATA_HPP_INCLUDED

#ifndef _WNO_PRAGMA_PUSH
#pragma pack(push,8);
#pragma enum int;
#endif

#ifndef _WOBJECT_HPP_INCLUDED
#  include "wobject.hpp"
#endif

class WGlobalMemory;

//
// WPrinterData
//

class WCMCLASS WPrinterData : public WObject {
    WDeclareSubclass( WPrinterData, WObject );

    public:

        /**********************************************************
         * Constructors and Destructors
         *********************************************************/

        WPrinterData();
        WPrinterData( WMemoryHandle devData, WMemoryHandle devName,
                      WBool deleteHandles=TRUE );
        WPrinterData( WGlobalMemory *devData, WGlobalMemory *devName );
        WPrinterData( const WPrinterData & pd, WBool copyData=FALSE );

        ~WPrinterData();

        WPrinterData& operator=( const WPrinterData & pd );

        /**********************************************************
         * Properties
         *********************************************************/

        // DeviceName

        WString GetDeviceName() const;

        // DriverName

        WString GetDriverName() const;

        // OutputName

        WString GetOutputName() const;

        // RawDeviceData

        WGlobalMemory *GetRawDeviceData() const;

        // RawDeviceName

        WGlobalMemory *GetRawDeviceName() const;

        // Valid

        WBool GetValid() const;

        /**********************************************************
         * Methods
         *********************************************************/

        // Clear

        void Clear();

        // Create

        WBool Create( WMemoryHandle devData, WMemoryHandle devName,
                      WBool deleteHandles=TRUE );
        WBool Create( WGlobalMemory *devData, WGlobalMemory *devName );
        WBool Create( const WPrinterData & pd, WBool copyData=FALSE );

        /**********************************************************
         * Private
         *********************************************************/

    protected:

        WGlobalMemory *_deviceData;
        WGlobalMemory *_deviceName;
};


#ifndef _WNO_PRAGMA_PUSH
#pragma enum pop;
#pragma pack(pop);
#endif

#endif // _WPRTDATA_HPP_INCLUDED
