/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995 by Watcom International Inc.  All rights     %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*/

/*************************************************************************
 *
 * WStatic -- Wrapper for the Windows 95 Static control.
 *
 *   Events:
 *
 *************************************************************************/

#ifndef _WSTATIC_HPP_INCLUDED
#define _WSTATIC_HPP_INCLUDED

#ifndef _WNO_PRAGMA_PUSH
#pragma pack(push,8);
#pragma enum int;
#endif

#ifndef _WCONTROL_HPP_INCLUDED
#  include "wcontrol.hpp"
#endif

//
// Static styles
//

#define WSSDefault              ((WStyle)0x5000010CL) // WS_VISIBLE|SS_LEFTNOWORDWRAP|WS_CHILD|SS_NOTIFY
#define WSSLeft                 ((WStyle)0x00000000L) // SS_LEFT
#define WSSCenter               ((WStyle)0x00000001L) // SS_CENTER
#define WSSRight                ((WStyle)0x00000002L) // SS_RIGHT
#define WSSIcon                 ((WStyle)0x00000003L) // SS_ICON
#define WSSBlackRect            ((WStyle)0x00000004L) // SS_BLACKRECT
#define WSSGrayRect             ((WStyle)0x00000005L) // SS_GRAYRECT
#define WSSWhiteRect            ((WStyle)0x00000006L) // SS_WHITERECT
#define WSSBlackFrame           ((WStyle)0x00000007L) // SS_BLACKFRAME
#define WSSGrayFrame            ((WStyle)0x00000008L) // SS_GRAYFRAME
#define WSSWhiteFrame           ((WStyle)0x00000009L) // SS_WHITEFRAME
#define WSSUserItem             ((WStyle)0x0000000AL) // SS_USERITEM
#define WSSSimple               ((WStyle)0x0000000BL) // SS_SIMPLE
#define WSSLeftNoWordWrap       ((WStyle)0x0000000CL) // SS_LEFTNOWORDWRAP
#define WSSOwnerDraw            ((WStyle)0x0000000DL) // SS_OWNERDRAW
#define WSSBitmap               ((WStyle)0x0000000EL) // SS_BITMAP
#define WSSEnhMetafile          ((WStyle)0x0000000FL) // SS_ENHMETAFILE
#define WSSEtchedHorz           ((WStyle)0x00000010L) // SS_ETCHEDHORZ
#define WSSEtchedVert           ((WStyle)0x00000011L) // SS_ETCHEDVERT
#define WSSEtchedFrame          ((WStyle)0x00000012L) // SS_ETCHEDFRAME
#define WSSNoPrefix             ((WStyle)0x00000080L) // SS_NOPREFIX
#define WSSNotify               ((WStyle)0x00000100L) // SS_NOTIFY
#define WSSCenterImage          ((WStyle)0x00000200L) // SS_CENTERIMAGE
#define WSSRightJust            ((WStyle)0x00000400L) // SS_RIGHTJUST
#define WSSRealSizeImage        ((WStyle)0x00000800L) // SS_REALSIZEIMAGE
#define WSSSunken               ((WStyle)0x00001000L) // SS_SUNKEN

class WCMCLASS WStatic : public WControl {
    WDeclareSubclass( WStatic, WControl );

    public:

        /**********************************************************
         * Constructors and Destructors
         *********************************************************/

        WStatic();
    
        ~WStatic();
    
        /**********************************************************
         * Properties
         *********************************************************/
    
        /**********************************************************
         * Methods
         *********************************************************/

        /**********************************************************
         * Overrides
         *********************************************************/
    
        virtual WStyle GetDefaultStyle() const;

        virtual const WChar * InitializeClass();

        /**********************************************************
         * Overrides
         *********************************************************/

        WBool HitTestEventHandler( WWindow * window,
                                   WHitTestEventData * event );
};

#ifndef _WNO_PRAGMA_PUSH
#pragma enum pop;
#pragma pack(pop);
#endif

#endif // _WSTATIC_HPP_INCLUDED
