/*************************************************************************
 *
 * WWizard -- Wrapper for the Windows 95 Property Sheet Wizard control.
 *
 *
 *   Events:
 *
 *************************************************************************/

#ifndef _WWIZARD_HPP_INCLUDED
#define _WWIZARD_HPP_INCLUDED
#pragma once

#ifndef _WNO_PRAGMA_PUSH
#pragma pack(push,8);
#pragma enum int;
#endif

#ifndef _WPROPSHT_HPP_INCLUDED
#  include "wpropsht.hpp"
#endif

enum WWizardButton {
    WWBBack,
    WWBNext,
    WWBFinish
};

class WCMCLASS WWizard : public WPropertySheet {
    WDeclareSubclass( WWizard, WPropertySheet );

    friend class WPropertySheetItem;

    public:

        /**********************************************************
         * Constructors and destructors
         *********************************************************/

        WWizard( WBool hasHelp=FALSE, WIcon * image=NULL,
                 const WChar * text=NULL, WBool isPropertyTitle=FALSE,
                 WInt startItemIndex=0, WPropertySheetInfo * infoArray=NULL,
                 WInt numItems=0, WBool autoButtonHandling=TRUE );
    
        ~WWizard();

        /**********************************************************
         * Properties
         *********************************************************/

        // AutoButtonHandling

        WBool GetAutoButtonHandling();
        WBool SetAutoButtonHandling( WBool autoButtonHandling );

        /**********************************************************
         * Methods
         *********************************************************/

        // EnableButton

        void EnableButton( WWizardButton buttonToEnable, WBool enable );

        // PressButton

        WBool PressButton( WWizardButton buttonToSimulate );

        /**********************************************************
         * Overrides
         *********************************************************/

        // ChangeCancelToClose

        virtual WBool ChangeCancelToClose();

        /**********************************************************
         * Data members
         *********************************************************/

    private:

        WBool                           _backEnabled;
        WBool                           _nextEnabled;
        WBool                           _finishEnabled;
        WBool                           _autoButtonHandling;
};

#ifndef _WNO_PRAGMA_PUSH
#pragma enum pop;
#pragma pack(pop);
#endif

#endif // _WWIZARD_HPP_INCLUDED
