#ifndef _DTJTYPED11_HPP
#define _DTJTYPED11_HPP

#include <stddef.h>
#include "dttype.hpp"

#define TYPE_ALIAS( _base, _alias )	\
typedef DT ## _base DT ## _alias;

/******************
 *** Color Type ***
 ******************/

class METAEXPORTCLASSDEF DTType_Color : public DTType {
    public:
	DTType_Color( const MMType * imp );
	~DTType_Color();

	virtual WBool		    Textify( WString &, DT_Textify ) const;
	virtual WBool		    DeTextify( const WString &, DT_Textify );

	virtual WBool		    operator==( const DTType & o );

	virtual WBool		    Set( const WColor & val );
	virtual const WColor &	    Get() const;

	virtual WBool		    Browse( WWindow * parent, DTObject * obj );

	virtual WUInt		    GetNumValues();
	virtual WString		    GetValue( WUInt i );

	static DTType *		    Instantiate( const MMType * );

    private:
	WColor		_c_value;
};


TYPE_ALIAS( Type_Color, Type_const_Color__ref_ );

/******************
 *** JFont Type ***
 ******************/

class METAEXPORTCLASSDEF DTType_JFont : public DTType {
    public:
	DTType_JFont( const MMType * imp );
	~DTType_JFont();

	virtual WBool		    Textify( WString &, DT_Textify ) const;
	virtual WBool		    DeTextify( const WString &, DT_Textify );

	virtual WBool		    operator==( const DTType & o );

	virtual WBool		    Set( const WFont & val );
	virtual const WFont &	    Get() const;

	virtual WBool		    Browse( WWindow * parent, DTObject * obj );

	static DTType *		    Instantiate( const MMType * );
    private:
	WFont		_value;
};

TYPE_ALIAS( Type_JFont, Type_const_JFont__ref_ );

extern WBool METAEXPORTDEF SearchAndReplace( WString & given,
			const WChar * search,
                        const WChar * replace );

#endif // _DTJTYPED11_HPP
