// Design Time Java Button  implementation. (HPP)

#ifndef _DTJCHECK11_HPP
#define _DTJCHECK11_HPP

#include "dtjcomp11.hpp"

class WJavaObject;

class METAEXPORTCLASSDEF DTJCheckBox11 : public DTJComponent11
{
    public:
        DTJCheckBox11( const MetaObject * pMetaObj );
        virtual ~DTJCheckBox11();

	//
	// DefaultStyle
	//
	//    The style with which new instances are created.  Default
	//    implementation returns GetWindow()->GetDefaultStyle().

	virtual WStyle		GetDefaultStyle() const;

        virtual void GenerateCode( MMCodeGeneration mmCodeGen,
				   ostream& src,
				   MMCodeGenerationParms& pGenParms );

        // Group
        //
        //    The variable name of the CheckboxGroup object.
        
        virtual const WString & GetGroup() const;
        
        virtual WBool SetGroup( const WChar * val );
        
        // GroupObj
        //
        //    The CheckboxGroup object (only used for Java form painting).
        
        virtual WJavaObject * GetGroupObj() const;
        
        virtual void SetGroupObj( WJavaObject * groupObj );

        virtual WJavaObject * FindGroupObj( const WString & group );
        
	virtual void GenClassName( WString & className ) const;

    protected:
        WString _group;
        WJavaObject * _groupObj;
};

class MMPropertyControl;
class MTPropertyControl;
extern MTPropertyControl * WCMDEF MakeJGroupList(const MMPropertyControl * c );

// needed for mdreader
typedef DTJCheckBox11 DTjava__dot__awt__dot__Checkbox__dot__11;
typedef WCheckBox java__dot__awt__dot__Checkbox__dot__11;

#endif // _DTJCHECK11_HPP
