// Design Time Java ComboBox implementation. (HPP)

#ifndef _DTJCOMBO_HPP
#define _DTJCOMBO_HPP

#include "dtjcomp.hpp"

class METAEXPORTCLASSDEF DTJComboBox : public DTJComponent
{
    public:
        DTJComboBox( const MetaObject * pMetaObj );
        virtual ~DTJComboBox();

	virtual WBool		GetHasInitialText() const;
	virtual WStringList&	GetListItems();

	// Save and Load DTInfo

	virtual WBool		HasDTInfo();
	virtual WBool		SaveDTInfo( SaveSource & );
	virtual WBool		LoadDTInfo( SaveBlock *, WBool );

	virtual WStyle		GetDefaultStyle() const;

	// ExtendedStyle: the ExtendedStyle property of the window nature 
	virtual WStyle		GetDefaultExtendedStyle() const;

        virtual void GenerateCode( MMCodeGeneration mmCodeGen,
				   ostream& src,
				   MMCodeGenerationParms& pGenParms );

	virtual void GenClassName( WString & className ) const;

    protected:
	WBool			GetDropDown() const;

    private:
    	WStringList		_listItems;
//	WBool			_hasInitialText;
};

class ImpComboBox : public WComboBox
{
    public:
        virtual WBool CloneWindow( WStyle newStyle, WStyle newExStyle,
                                   void * data=NULL );
	DTJComboBox * _dt;
};


// needed for mdreader
typedef DTJComboBox DTjava__dot__awt__dot__Choice__dot__102;
typedef ImpComboBox java__dot__awt__dot__Choice__dot__102;


#endif // _DTJCOMBO_HPP
