// Design Time Java ComboBox implementation. (HPP)

#ifndef _DTJCOMBO11_HPP
#define _DTJCOMBO11_HPP

#include "dtjcomp11.hpp"

class METAEXPORTCLASSDEF DTJComboBox11 : public DTJComponent11
{
    public:
        DTJComboBox11( const MetaObject * pMetaObj );
        virtual ~DTJComboBox11();

	virtual WBool		GetHasInitialText() const;
	virtual WStringList&	GetListItems();

	// Save and Load DTInfo

	virtual WBool		HasDTInfo();
	virtual WBool		SaveDTInfo( SaveSource & );
	virtual WBool		LoadDTInfo( SaveBlock *, WBool );

	virtual WStyle		GetDefaultStyle() const;

	// ExtendedStyle: the ExtendedStyle property of the window nature 
	virtual WStyle		GetDefaultExtendedStyle() const;

        virtual void GenerateCode( MMCodeGeneration mmCodeGen,
				   ostream& src,
				   MMCodeGenerationParms& pGenParms );

	virtual void GenClassName( WString & className ) const;

    protected:
	WBool			GetDropDown() const;

    private:
    	WStringList		_listItems;
//	WBool			_hasInitialText;
};

class ImpComboBox11 : public WComboBox
{
    public:
        virtual WBool CloneWindow( WStyle newStyle, WStyle newExStyle,
                                   void * data=NULL );
	DTJComboBox11 * _dt;
};


// needed for mdreader
typedef DTJComboBox11 DTjava__dot__awt__dot__Choice__dot__11;
typedef ImpComboBox11 java__dot__awt__dot__Choice__dot__11;


#endif // _DTJCOMBO11_HPP
