// Design Time Java Label implementation. (HPP)

#ifndef _DTJLABEL11_HPP
#define _DTJLABEL11_HPP

#include "dtjcomp11.hpp"
                      
class METAEXPORTCLASSDEF DTJLabel11 : public DTJComponent11
{
    public:
        DTJLabel11( const MetaObject * pMetaObj );
        virtual ~DTJLabel11();
        
	//
	// Style
	//
	//    The Windows style property of the associated Window.
	//    This doesn't necessarily match GetWindow()->GetStyle()
	//    because some styles are deferred until run-time (such
	//    as WSVisible).

	virtual WStyle		GetStyle() const;
	virtual WBool		SetStyle( WStyle stl, WBool clone=FALSE );

	//
	// DefaultStyle
	//
	//    The style with which new instances are created.  Default
	//    implementation returns GetWindow()->GetDefaultStyle().

	virtual WStyle		GetDefaultStyle() const;

        virtual void GenerateCode( MMCodeGeneration mmCodeGen,
				   ostream& src,
				   MMCodeGenerationParms& pGenParms );

	virtual void GenerateTextProp( const WString& objPrefix, ostream& src,
				       MMJCodeGenerationParms * ) const;

	virtual void GenClassName( WString & className ) const;

	virtual void EmitProperty( const WString& objPrefix, ostream& src,
				   const MMProperty * prop ) const;

    protected:
        virtual WStyle CheckExtraStyles(WStyle style);
};

// needed for mdreader
typedef DTJLabel11 DTjava__dot__awt__dot__Label__dot__11;
typedef WLabel java__dot__awt__dot__Label__dot__11;

#endif // _DTJLABEL11_HPP
