// Design Time Java List Box implementation. (HPP)

#ifndef _DTJLIST_HPP
#define _DTJLIST_HPP

#include "dtjcomp.hpp"
                      
class METAEXPORTCLASSDEF DTJList : public DTJComponent
{
    public:
        DTJList( const MetaObject * pMetaObj );
        virtual ~DTJList();

	virtual WBool		GetHasInitialText() const;
       
	// Save and Load DTInfo

	virtual WBool		HasDTInfo();
	virtual WBool		SaveDTInfo( SaveSource & );
	virtual WBool		LoadDTInfo( SaveBlock *, WBool );
       
	//
	// Style
	//
	//    The Windows style property of the associated Window.
	//    This doesn't necessarily match GetWindow()->GetStyle()
	//    because some styles are deferred until run-time (such
	//    as WSVisible).

	virtual WStyle		GetStyle() const;
	virtual WBool		SetStyle( WStyle stl, WBool clone=FALSE );

	//
	// DefaultStyle
	//
	//    The style with which new instances are created.  Default
	//    implementation returns GetWindow()->GetDefaultStyle().

	virtual WStyle		GetDefaultStyle() const;

	//
	// ExtendedStyle
	//
	//    The ExtendedStyle property of the window nature.

	virtual WStyle		GetExtendedStyle() const;
	virtual WBool		SetExtendedStyle( WStyle style, WBool clone=FALSE );

	//
	// DefaultExtendedStyle
	//
	//    See DefaultStyle

	virtual WStyle		GetDefaultExtendedStyle() const;

        virtual void GenerateCode( MMCodeGeneration mmCodeGen,
				   ostream& src,
				   MMCodeGenerationParms& pGenParms );

	virtual void GenClassName( WString & className ) const;

    protected:
        virtual WStyle CheckExtraStyles(WStyle style);
};

// needed for mdreader
typedef DTJList DTjava__dot__awt__dot__List__dot__102;
typedef WListBox java__dot__awt__dot__List__dot__102;

#endif // _DTJLIST_HPP
