#ifndef _DTJOLEOB11_HPP
#define _DTJOLEOB11_HPP

#include "dtjobjct11.hpp"

class MetaObject;
struct BindableOlePropInfo;

class METAEXPORTCLASSDEF DTJOleObject11 : public DTJObject11 {
    public:
	DTJOleObject11( const MetaObject * meta );
	~DTJOleObject11();

	virtual	WJavaObject*	GetWJavaObject() const;

	virtual WString		GetObjectPrefix() const;

	virtual WString		DTGetName() const;

	virtual WBool		Create( WWindow * parent, const WRect & r,
				        const WChar * text, WStyle style,
					WStyle exStyle, void * data = NULL,
					WBool isLoading = FALSE );

	virtual void		DTGetRectangle( WRect & r, WBool abs = FALSE ) const;
	virtual void		DTGetClientRectangle( WRect & r ) const;
        virtual void		DTSetRectangle( const WRect & r, WBool abs=FALSE );
	virtual void		DTBringToTop();
	virtual void		DTRepaint( WRect * rect=NULL );
	virtual WWindow *	DTGetParent() const;
	virtual WBool 		DTSetEventHandler( WEventID id,
						 WObject * object,
						 WEventHandler handler,
						 void *userdata=NULL );

	virtual WStyle		GetStyle() const;
	virtual WBool		SetStyle( WStyle stl, WBool clone=FALSE );
	virtual WStyle		GetDefaultStyle() const;

	virtual WStyle		GetExtendedStyle() const;
	virtual WBool		SetExtendedStyle( WStyle style, WBool clone=FALSE );
	virtual WStyle		GetDefaultExtendedStyle() const;

	virtual void		GenClassName( WString & ) const;

	// Save and Load DTInfo
	virtual WBool		HasDTInfo();
	virtual WBool		SaveDTInfo( SaveSource & );
	virtual WBool		LoadDTInfo( SaveBlock *, WBool );

	virtual WBool		GetIsResizeable();
	virtual WBool		CreateEventPopupMenu( WPopupMenu * popup );

	virtual WBool		GetOLEPropertyList( WInt *num, BindableOlePropInfo **propList );

	// Overrides
	virtual void 		DTSetName( const WString & name );

	virtual void GenerateImports( ostream& src,
			  	      MMJCodeGenerationParms* pGenParms ) const;

	virtual WBool CanCreateNonImplementationJavaObj() const;

    public:
	virtual void		AmendPopup( WPopupMenu *popup, WBool before );
	virtual void		SetForm( DTFormEditBase * );

        virtual void GenerateCode( MMCodeGeneration mmCodeGen,
				   ostream& src,
				   MMCodeGenerationParms& pGenParms );

    protected:

	virtual void GenerateAddListenerCode( const WString prefix,
                                              ostream& src,
					      MMJCodeGenerationParms* pGenParms ) const;

	WOleObject *		GetWOleObject() const;
	WBool			HdlOleMenuTrampoline( WObject * src, WEventData * data );

    private:
	WBool			_loadFromFile;
	WString			_oleID;
	WInt			_lastOleMenuItem;
	BindableOlePropInfo *	_propList;
	WInt			_numProps;
	WStringArray		_dtProps;
	WStringArray		_dtPropValues;
};

class METAEXPORTCLASSDEF DTJOleProgrammableObject11 :  public DTJObject11 {
    public:
        DTJOleProgrammableObject11( const MetaObject * meta );
        ~DTJOleProgrammableObject11();

    protected:
        virtual void GenerateCode( MMCodeGeneration mmCodeGen,
				   ostream& src,
				   MMCodeGenerationParms& pGenParms );
};

// needed for mdreader
typedef DTJOleObject11 DTpowersoft__dot__powerj__dot__ui__dot__JOleObject__dot__11;
typedef WOleObject powersoft__dot__powerj__dot__ui__dot__JOleObject__dot__11;
typedef DTJOleObject11 DTpowersoft__dot__powerj__dot__ui__dot__JVisualOleObject__dot__11;
typedef WOleObject powersoft__dot__powerj__dot__ui__dot__JVisualOleObject__dot__11;

#endif // _DTJOLEOB11_HPP
