// Design Time Java PictureBox implementation. (HPP)

#ifndef _DTJPICTBX11_HPP
#define _DTJPICTBX11_HPP

#include "dtjcomp11.hpp"
#include "dtjpcanv11.hpp"
#include "dtjpicbn11.hpp"

enum ImagePosition {
    eImagePositionDEFAULT = 0,
    eImagePositionCENTER  = 1
};

class METAEXPORTCLASSDEF DTJPictureBox11 : public DTJPaintCanvas11
{
    public:
        DTJPictureBox11( const MetaObject * pMetaObj );
        virtual ~DTJPictureBox11();

        // URLType
        //
        //    The URL type: Absolute or relative based on the URL of
        //    the document or of the applet code.
                
        virtual URLType GetURLType() const;
        virtual WBool   SetURLType( URLType t );

	virtual void GenClassName( WString & className ) const;

        virtual WBool Create( WWindow * parent, const WRect & r,
                              const WChar * text, WStyle style,
                              WStyle exStyle, void * data, WBool isLoading );
                               
        virtual void GenerateCode( MMCodeGeneration mmCodeGen,
                                   ostream& src,
                                   MMCodeGenerationParms& pGenParms );

        // The following properties are for C++ form painting only.
        virtual WLong GetInsetsTop() const;
        virtual void  SetInsetsTop( WLong value );
        virtual WLong GetInsetsBottom() const;
        virtual void  SetInsetsBottom( WLong value );
        virtual WLong GetInsetsLeft() const;
        virtual void  SetInsetsLeft( WLong value );
        virtual WLong GetInsetsRight() const;
        virtual void  SetInsetsRight( WLong value );
        virtual const WChar * GetURL() const;
        virtual void  SetURL( const WString & url );
        virtual const ImagePosition GetImagePosition() const;
        virtual void  SetImagePosition( ImagePosition value );
        virtual const WBool GetScaleImage() const;
        virtual void  SetScaleImage( WBool value );

	virtual WBool GetImplements( const WString & ) const;

    protected:
    	virtual void GenerateCreate( const WString& objPrefix,
	                             ostream& src,
		  		     MMJCodeGenerationParms* pGenParms ) const;

    private:
        WLong _insets_top;
        WLong _insets_bottom;
        WLong _insets_left;
        WLong _insets_right;
        
        URLType _url_type;
        WString _url;

        ImagePosition _image_position;
        WBool         _scale_image;
};

// needed for mdreader
typedef DTJPictureBox11 DTpowersoft__dot__powerj__dot__ui__dot__PictureBox__dot__11;
typedef WPictureBox powersoft__dot__powerj__dot__ui__dot__PictureBox__dot__11;

#endif // _DTJPICTBX11_HPP
