// Design Time Java Text Component implementation. (HPP)

#ifndef _DTJTEXT_HPP
#define _DTJTEXT_HPP

#include "dtjcomp.hpp"
                      
class METAEXPORTCLASSDEF DTJTextComponent : public DTJComponent
{
    public:
        DTJTextComponent( const MetaObject * pMetaObj );
        virtual ~DTJTextComponent();

	//
	// Style
	//
	//    The Windows style property of the associated Window.
	//    This doesn't necessarily match GetWindow()->GetStyle()
	//    because some styles are deferred until run-time (such
	//    as WSVisible).

	virtual WStyle		GetStyle() const;

	//
	// DefaultStyle
	//
	//    The style with which new instances are created.  Default
	//    implementation returns GetWindow()->GetDefaultStyle().

	virtual WStyle		GetDefaultStyle() const;

	//
	// ExtendedStyle
	//
	//    The ExtendedStyle property of the window nature.

	virtual WStyle		GetExtendedStyle() const;
	virtual WBool		SetExtendedStyle( WStyle style, WBool clone=FALSE );

	//
	// DefaultExtendedStyle
	//
	//    See DefaultStyle

	virtual WStyle		GetDefaultExtendedStyle() const;

        virtual void GenerateCode( MMCodeGeneration mmCodeGen,
				   ostream& src,
				   MMCodeGenerationParms& pGenParms );

	virtual void GenerateTextProp( const WString& objPrefix, ostream& src,
				       MMJCodeGenerationParms * ) const;
};

// needed for mdreader
typedef DTJTextComponent DTjava__dot__awt__dot__TextComponent__dot__102;
typedef WTextBox java__dot__awt__dot__TextComponent__dot__102;

#endif // _DTJTEXT_HPP
